###############################################################################
#   Instructions to Make, for compilation of ISODE processes for generic SVR4
###############################################################################

###############################################################################
#
# $Header: /lusr/src/cvs/isode-snmp/config/solaris.make,v 1.1.1.1 1997/01/31 19:06:26 ljb Exp $
#
#
# $Log: solaris.make,v $
# Revision 1.1.1.1  1997/01/31 19:06:26  ljb
# Imported ISODE SNMP sources
#
# Revision 9.0  1992/06/16  12:08:13  isode
# Release 8.0
#
#
###############################################################################

###############################################################################
#
#				 NOTICE
#
#    Acquisition, use, and distribution of this module and related
#    materials are subject to the restrictions of a license agreement.
#    Consult the Preface in the User's Manual for the full terms of
#    this agreement.
#
###############################################################################

###############################################################################
#
# Donated to ISODE by X-Tel Services Ltd
#
# Based on ICL DRS/NX 6000 Version 4.0  Level 4  Increment 4
#
###############################################################################

###############################################################################
# Options
###############################################################################

OPTIONS	=	-I. -I$(TOPDIR)h $(PEPYPATH) $(KRBOPT)

HDIR	=	$(TOPDIR)h/
UTILDIR	=	$(TOPDIR)util/
BINDIR	=	/usr/local/bin/
SBINDIR	=	/usr/local/sbin/
ETCDIR	=	/etc/
LOGDIR	=	/var/log/
INCDIRM	=	/usr/local/include/isode
INCDIR	=	$(INCDIRM)/
PEPYDIRM=	$(INCDIR)pepy
PEPYDIR	=	$(PEPYDIRM)/
PEPSYDIRM=	$(INCDIR)pepsy
PEPSYDIR=	$(PEPSYDIRM)/
LIBDIR	=	/usr/local/lib/
LINTDIR	=	/usr/local/lib/lint

LIBISODE=	$(TOPDIR)libisode.a
LIBDSAP	=	$(TOPDIR)libdsap.a

SYSTEM	=	-sys5r4
MANDIR	=	/usr/local/man/
MANOPTS	=	-local


###############################################################################
# Shared libraries
###############################################################################

#    You can build the ISODE and DSAP libraries dynamically.
#    This option is not the default as its portability is questionable.
#    We advise you build statically first, then when that works, you
#    may wish to try the shared library options.
#
#    If you have changed LIBDIR above, shared libraries may not work.

#    First, comment out the definitions of LIBISODE and LIBDSAP above

#    Second, uncomment these three lines:

#SHAREDLIB=      shared
#LIBISODE=	-L$(TOPDIR) -lisode -lm 
#LIBDSAP=	-L$(TOPDIR) -ldsap

#    Third, add
#		-K PIC
#    to LIBCFLAGS below

#    You will need to install the libraries before the binaries will run.

###############################################################################
# Programs and Libraries
###############################################################################

MAKE	=	./make DESTDIR=$(DESTDIR) $(MFLAGS) -k
SHELL	=	/bin/sh

# For generic Sys5 R4 use /usr/bin/cc and /usr/bin/ld explicitly, 
# otherwise you may pick up /usr/ucb/cc.  If you don't have SVR4_UCB
# defined that would be a complete flop!
#
# If SVR4_UCB is defined you'll need to use /usr/ucb/cc and /usr/ucb/ld
#
CC      =	gcc -fwritable-strings
LD	=	/usr/ucb/ld
CFLAGS  =       -O2 $(OPTIONS) $(LOPTIONS) 
LIBCFLAGS=      $(CFLAGS)
LINT    =	/usr/bin/lint
LFLAGS  =	-s $(OPTIONS)
LDCC	=	$(CC)
LDFLAGS =
ARFLAGS	=

LN	=	ln

# You won't need -lsocket or -nsl if you have SVR4_UCB defined.
LSOCKET	=	-lsocket -lnsl -lelf $(KRBLIB)

# You won't need -lsocket or -nsl if you have SVR4_UCB defined.
#LSOCKET	=	$(KRBLIB)

###############################################################################
# Generation Rules for library modules
###############################################################################

.c.o:;		$(CC) $(LIBCFLAGS) -c $*.c
