/* compiled  - touched 2/19/97 - ljb */

#include <stdio.h>
#include "objects.h"

static unsigned int _elems[] = {
      0, 0, /* ccitt */ 
      0, 0, 0, /* localAgent */ 
      1, 0, /* iso */ 
      1, 3, 6, 1, 0, /* internet */ 
      1, 3, 6, 1, 1, 0, /* directory */ 
      1, 3, 6, 1, 2, 0, /* mgmt */ 
      1, 3, 6, 1, 2, 1, 0, /* mib-2 */ 
      1, 3, 6, 1, 2, 1, 1, 0, /* system */ 
      1, 3, 6, 1, 2, 1, 1, 1, 0, /* sysDescr */ 
      1, 3, 6, 1, 2, 1, 1, 2, 0, /* sysObjectID */ 
      1, 3, 6, 1, 2, 1, 1, 3, 0, /* sysUpTime */ 
      1, 3, 6, 1, 2, 1, 1, 4, 0, /* sysContact */ 
      1, 3, 6, 1, 2, 1, 1, 5, 0, /* sysName */ 
      1, 3, 6, 1, 2, 1, 1, 6, 0, /* sysLocation */ 
      1, 3, 6, 1, 2, 1, 1, 7, 0, /* sysServices */ 
      1, 3, 6, 1, 2, 1, 2, 0, /* interfaces */ 
      1, 3, 6, 1, 2, 1, 2, 1, 0, /* ifNumber */ 
      1, 3, 6, 1, 2, 1, 2, 2, 0, /* ifTable */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 0, /* ifEntry */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 1, 0, /* ifIndex */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 2, 0, /* ifDescr */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 3, 0, /* ifType */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 4, 0, /* ifMtu */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 5, 0, /* ifSpeed */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 6, 0, /* ifPhysAddress */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 7, 0, /* ifAdminStatus */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 8, 0, /* ifOperStatus */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 9, 0, /* ifLastChange */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 10, 0, /* ifInOctets */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 11, 0, /* ifInUcastPkts */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 12, 0, /* ifInNUcastPkts */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 13, 0, /* ifInDiscards */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 14, 0, /* ifInErrors */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 15, 0, /* ifInUnknownProtos */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 16, 0, /* ifOutOctets */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 17, 0, /* ifOutUcastPkts */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 18, 0, /* ifOutNUcastPkts */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 19, 0, /* ifOutDiscards */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 20, 0, /* ifOutErrors */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 21, 0, /* ifOutQLen */ 
      1, 3, 6, 1, 2, 1, 2, 2, 1, 22, 0, /* ifSpecific */ 
      1, 3, 6, 1, 2, 1, 3, 0, /* at */ 
      1, 3, 6, 1, 2, 1, 3, 1, 0, /* atTable */ 
      1, 3, 6, 1, 2, 1, 3, 1, 1, 0, /* atEntry */ 
      1, 3, 6, 1, 2, 1, 3, 1, 1, 1, 0, /* atIfIndex */ 
      1, 3, 6, 1, 2, 1, 3, 1, 1, 2, 0, /* atPhysAddress */ 
      1, 3, 6, 1, 2, 1, 3, 1, 1, 3, 0, /* atNetAddress */ 
      1, 3, 6, 1, 2, 1, 4, 0, /* ip */ 
      1, 3, 6, 1, 2, 1, 4, 1, 0, /* ipForwarding */ 
      1, 3, 6, 1, 2, 1, 4, 2, 0, /* ipDefaultTTL */ 
      1, 3, 6, 1, 2, 1, 4, 3, 0, /* ipInReceives */ 
      1, 3, 6, 1, 2, 1, 4, 4, 0, /* ipInHdrErrors */ 
      1, 3, 6, 1, 2, 1, 4, 5, 0, /* ipInAddrErrors */ 
      1, 3, 6, 1, 2, 1, 4, 6, 0, /* ipForwDatagrams */ 
      1, 3, 6, 1, 2, 1, 4, 7, 0, /* ipInUnknownProtos */ 
      1, 3, 6, 1, 2, 1, 4, 8, 0, /* ipInDiscards */ 
      1, 3, 6, 1, 2, 1, 4, 9, 0, /* ipInDelivers */ 
      1, 3, 6, 1, 2, 1, 4, 10, 0, /* ipOutRequests */ 
      1, 3, 6, 1, 2, 1, 4, 11, 0, /* ipOutDiscards */ 
      1, 3, 6, 1, 2, 1, 4, 12, 0, /* ipOutNoRoutes */ 
      1, 3, 6, 1, 2, 1, 4, 13, 0, /* ipReasmTimeout */ 
      1, 3, 6, 1, 2, 1, 4, 14, 0, /* ipReasmReqds */ 
      1, 3, 6, 1, 2, 1, 4, 15, 0, /* ipReasmOKs */ 
      1, 3, 6, 1, 2, 1, 4, 16, 0, /* ipReasmFails */ 
      1, 3, 6, 1, 2, 1, 4, 17, 0, /* ipFragOKs */ 
      1, 3, 6, 1, 2, 1, 4, 18, 0, /* ipFragFails */ 
      1, 3, 6, 1, 2, 1, 4, 19, 0, /* ipFragCreates */ 
      1, 3, 6, 1, 2, 1, 4, 20, 0, /* ipAddrTable */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 0, /* ipAddrEntry */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 1, 0, /* ipAdEntAddr */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 2, 0, /* ipAdEntIfIndex */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 3, 0, /* ipAdEntNetMask */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 4, 0, /* ipAdEntBcastAddr */ 
      1, 3, 6, 1, 2, 1, 4, 20, 1, 5, 0, /* ipAdEntReasmMaxSize */ 
      1, 3, 6, 1, 2, 1, 4, 21, 0, /* ipRouteTable */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 0, /* ipRouteEntry */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 1, 0, /* ipRouteDest */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 2, 0, /* ipRouteIfIndex */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 3, 0, /* ipRouteMetric1 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 4, 0, /* ipRouteMetric2 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 5, 0, /* ipRouteMetric3 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 6, 0, /* ipRouteMetric4 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 7, 0, /* ipRouteNextHop */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 8, 0, /* ipRouteType */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 9, 0, /* ipRouteProto */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 10, 0, /* ipRouteAge */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 11, 0, /* ipRouteMask */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 12, 0, /* ipRouteMetric5 */ 
      1, 3, 6, 1, 2, 1, 4, 21, 1, 13, 0, /* ipRouteInfo */ 
      1, 3, 6, 1, 2, 1, 4, 22, 0, /* ipNetToMediaTable */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 0, /* ipNetToMediaEntry */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 1, 0, /* ipNetToMediaIfIndex */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 2, 0, /* ipNetToMediaPhysAddress */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 3, 0, /* ipNetToMediaNetAddress */ 
      1, 3, 6, 1, 2, 1, 4, 22, 1, 4, 0, /* ipNetToMediaType */ 
      1, 3, 6, 1, 2, 1, 4, 23, 0, /* ipRoutingDiscards */ 
      1, 3, 6, 1, 2, 1, 4, 24, 0, /* ipForward */ 
      1, 3, 6, 1, 2, 1, 4, 24, 1, 0, /* ipForwardNumber */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 0, /* ipForwardTable */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 0, /* ipForwardEntry */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 1, 0, /* ipForwardDest */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 2, 0, /* ipForwardMask */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 3, 0, /* ipForwardPolicy */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 4, 0, /* ipForwardNextHop */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 5, 0, /* ipForwardIfIndex */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 6, 0, /* ipForwardType */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 7, 0, /* ipForwardProto */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 8, 0, /* ipForwardAge */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 9, 0, /* ipForwardInfo */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 10, 0, /* ipForwardNextHopAS */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 11, 0, /* ipForwardMetric1 */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 12, 0, /* ipForwardMetric2 */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 13, 0, /* ipForwardMetric3 */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 14, 0, /* ipForwardMetric4 */ 
      1, 3, 6, 1, 2, 1, 4, 24, 2, 1, 15, 0, /* ipForwardMetric5 */ 
      1, 3, 6, 1, 2, 1, 5, 0, /* icmp */ 
      1, 3, 6, 1, 2, 1, 5, 1, 0, /* icmpInMsgs */ 
      1, 3, 6, 1, 2, 1, 5, 2, 0, /* icmpInErrors */ 
      1, 3, 6, 1, 2, 1, 5, 3, 0, /* icmpInDestUnreachs */ 
      1, 3, 6, 1, 2, 1, 5, 4, 0, /* icmpInTimeExcds */ 
      1, 3, 6, 1, 2, 1, 5, 5, 0, /* icmpInParmProbs */ 
      1, 3, 6, 1, 2, 1, 5, 6, 0, /* icmpInSrcQuenchs */ 
      1, 3, 6, 1, 2, 1, 5, 7, 0, /* icmpInRedirects */ 
      1, 3, 6, 1, 2, 1, 5, 8, 0, /* icmpInEchos */ 
      1, 3, 6, 1, 2, 1, 5, 9, 0, /* icmpInEchoReps */ 
      1, 3, 6, 1, 2, 1, 5, 10, 0, /* icmpInTimestamps */ 
      1, 3, 6, 1, 2, 1, 5, 11, 0, /* icmpInTimestampReps */ 
      1, 3, 6, 1, 2, 1, 5, 12, 0, /* icmpInAddrMasks */ 
      1, 3, 6, 1, 2, 1, 5, 13, 0, /* icmpInAddrMaskReps */ 
      1, 3, 6, 1, 2, 1, 5, 14, 0, /* icmpOutMsgs */ 
      1, 3, 6, 1, 2, 1, 5, 15, 0, /* icmpOutErrors */ 
      1, 3, 6, 1, 2, 1, 5, 16, 0, /* icmpOutDestUnreachs */ 
      1, 3, 6, 1, 2, 1, 5, 17, 0, /* icmpOutTimeExcds */ 
      1, 3, 6, 1, 2, 1, 5, 18, 0, /* icmpOutParmProbs */ 
      1, 3, 6, 1, 2, 1, 5, 19, 0, /* icmpOutSrcQuenchs */ 
      1, 3, 6, 1, 2, 1, 5, 20, 0, /* icmpOutRedirects */ 
      1, 3, 6, 1, 2, 1, 5, 21, 0, /* icmpOutEchos */ 
      1, 3, 6, 1, 2, 1, 5, 22, 0, /* icmpOutEchoReps */ 
      1, 3, 6, 1, 2, 1, 5, 23, 0, /* icmpOutTimestamps */ 
      1, 3, 6, 1, 2, 1, 5, 24, 0, /* icmpOutTimestampReps */ 
      1, 3, 6, 1, 2, 1, 5, 25, 0, /* icmpOutAddrMasks */ 
      1, 3, 6, 1, 2, 1, 5, 26, 0, /* icmpOutAddrMaskReps */ 
      1, 3, 6, 1, 2, 1, 6, 0, /* tcp */ 
      1, 3, 6, 1, 2, 1, 6, 1, 0, /* tcpRtoAlgorithm */ 
      1, 3, 6, 1, 2, 1, 6, 2, 0, /* tcpRtoMin */ 
      1, 3, 6, 1, 2, 1, 6, 3, 0, /* tcpRtoMax */ 
      1, 3, 6, 1, 2, 1, 6, 4, 0, /* tcpMaxConn */ 
      1, 3, 6, 1, 2, 1, 6, 5, 0, /* tcpActiveOpens */ 
      1, 3, 6, 1, 2, 1, 6, 6, 0, /* tcpPassiveOpens */ 
      1, 3, 6, 1, 2, 1, 6, 7, 0, /* tcpAttemptFails */ 
      1, 3, 6, 1, 2, 1, 6, 8, 0, /* tcpEstabResets */ 
      1, 3, 6, 1, 2, 1, 6, 9, 0, /* tcpCurrEstab */ 
      1, 3, 6, 1, 2, 1, 6, 10, 0, /* tcpInSegs */ 
      1, 3, 6, 1, 2, 1, 6, 11, 0, /* tcpOutSegs */ 
      1, 3, 6, 1, 2, 1, 6, 12, 0, /* tcpRetransSegs */ 
      1, 3, 6, 1, 2, 1, 6, 13, 0, /* tcpConnTable */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 0, /* tcpConnEntry */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 1, 0, /* tcpConnState */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 2, 0, /* tcpConnLocalAddress */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 3, 0, /* tcpConnLocalPort */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 4, 0, /* tcpConnRemAddress */ 
      1, 3, 6, 1, 2, 1, 6, 13, 1, 5, 0, /* tcpConnRemPort */ 
      1, 3, 6, 1, 2, 1, 6, 14, 0, /* tcpInErrs */ 
      1, 3, 6, 1, 2, 1, 6, 15, 0, /* tcpOutRsts */ 
      1, 3, 6, 1, 2, 1, 7, 0, /* udp */ 
      1, 3, 6, 1, 2, 1, 7, 1, 0, /* udpInDatagrams */ 
      1, 3, 6, 1, 2, 1, 7, 2, 0, /* udpNoPorts */ 
      1, 3, 6, 1, 2, 1, 7, 3, 0, /* udpInErrors */ 
      1, 3, 6, 1, 2, 1, 7, 4, 0, /* udpOutDatagrams */ 
      1, 3, 6, 1, 2, 1, 7, 5, 0, /* udpTable */ 
      1, 3, 6, 1, 2, 1, 7, 5, 1, 0, /* udpEntry */ 
      1, 3, 6, 1, 2, 1, 7, 5, 1, 1, 0, /* udpLocalAddress */ 
      1, 3, 6, 1, 2, 1, 7, 5, 1, 2, 0, /* udpLocalPort */ 
      1, 3, 6, 1, 2, 1, 8, 0, /* egp */ 
      1, 3, 6, 1, 2, 1, 8, 1, 0, /* egpInMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 2, 0, /* egpInErrors */ 
      1, 3, 6, 1, 2, 1, 8, 3, 0, /* egpOutMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 4, 0, /* egpOutErrors */ 
      1, 3, 6, 1, 2, 1, 8, 5, 0, /* egpNeighTable */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 0, /* egpNeighEntry */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 1, 0, /* egpNeighState */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 2, 0, /* egpNeighAddr */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 3, 0, /* egpNeighAs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 4, 0, /* egpNeighInMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 5, 0, /* egpNeighInErrs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 6, 0, /* egpNeighOutMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 7, 0, /* egpNeighOutErrs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 8, 0, /* egpNeighInErrMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 9, 0, /* egpNeighOutErrMsgs */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 10, 0, /* egpNeighStateUps */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 11, 0, /* egpNeighStateDowns */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 12, 0, /* egpNeighIntervalHello */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 13, 0, /* egpNeighIntervalPoll */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 14, 0, /* egpNeighMode */ 
      1, 3, 6, 1, 2, 1, 8, 5, 1, 15, 0, /* egpNeighEventTrigger */ 
      1, 3, 6, 1, 2, 1, 8, 6, 0, /* egpAs */ 
      1, 3, 6, 1, 2, 1, 10, 0, /* transmission */ 
      1, 3, 6, 1, 2, 1, 11, 0, /* snmp */ 
      1, 3, 6, 1, 2, 1, 11, 1, 0, /* snmpInPkts */ 
      1, 3, 6, 1, 2, 1, 11, 2, 0, /* snmpOutPkts */ 
      1, 3, 6, 1, 2, 1, 11, 3, 0, /* snmpInBadVersions */ 
      1, 3, 6, 1, 2, 1, 11, 4, 0, /* snmpInBadCommunityNames */ 
      1, 3, 6, 1, 2, 1, 11, 5, 0, /* snmpInBadCommunityUses */ 
      1, 3, 6, 1, 2, 1, 11, 6, 0, /* snmpInASNParseErrs */ 
      1, 3, 6, 1, 2, 1, 11, 8, 0, /* snmpInTooBigs */ 
      1, 3, 6, 1, 2, 1, 11, 9, 0, /* snmpInNoSuchNames */ 
      1, 3, 6, 1, 2, 1, 11, 10, 0, /* snmpInBadValues */ 
      1, 3, 6, 1, 2, 1, 11, 11, 0, /* snmpInReadOnlys */ 
      1, 3, 6, 1, 2, 1, 11, 12, 0, /* snmpInGenErrs */ 
      1, 3, 6, 1, 2, 1, 11, 13, 0, /* snmpInTotalReqVars */ 
      1, 3, 6, 1, 2, 1, 11, 14, 0, /* snmpInTotalSetVars */ 
      1, 3, 6, 1, 2, 1, 11, 15, 0, /* snmpInGetRequests */ 
      1, 3, 6, 1, 2, 1, 11, 16, 0, /* snmpInGetNexts */ 
      1, 3, 6, 1, 2, 1, 11, 17, 0, /* snmpInSetRequests */ 
      1, 3, 6, 1, 2, 1, 11, 18, 0, /* snmpInGetResponses */ 
      1, 3, 6, 1, 2, 1, 11, 19, 0, /* snmpInTraps */ 
      1, 3, 6, 1, 2, 1, 11, 20, 0, /* snmpOutTooBigs */ 
      1, 3, 6, 1, 2, 1, 11, 21, 0, /* snmpOutNoSuchNames */ 
      1, 3, 6, 1, 2, 1, 11, 22, 0, /* snmpOutBadValues */ 
      1, 3, 6, 1, 2, 1, 11, 24, 0, /* snmpOutGenErrs */ 
      1, 3, 6, 1, 2, 1, 11, 25, 0, /* snmpOutGetRequests */ 
      1, 3, 6, 1, 2, 1, 11, 26, 0, /* snmpOutGetNexts */ 
      1, 3, 6, 1, 2, 1, 11, 27, 0, /* snmpOutSetRequests */ 
      1, 3, 6, 1, 2, 1, 11, 28, 0, /* snmpOutGetResponses */ 
      1, 3, 6, 1, 2, 1, 11, 29, 0, /* snmpOutTraps */ 
      1, 3, 6, 1, 2, 1, 11, 30, 0, /* snmpEnableAuthenTraps */ 
      1, 3, 6, 1, 2, 1, 14, 0, /* ospf */ 
      1, 3, 6, 1, 2, 1, 14, 1, 0, /* ospfGeneralGroup */ 
      1, 3, 6, 1, 2, 1, 14, 1, 1, 0, /* ospfRouterId */ 
      1, 3, 6, 1, 2, 1, 14, 1, 2, 0, /* ospfAdminStat */ 
      1, 3, 6, 1, 2, 1, 14, 1, 3, 0, /* ospfVersionNumber */ 
      1, 3, 6, 1, 2, 1, 14, 1, 4, 0, /* ospfAreaBdrRtrStatus */ 
      1, 3, 6, 1, 2, 1, 14, 1, 5, 0, /* ospfASBdrRtrStatus */ 
      1, 3, 6, 1, 2, 1, 14, 1, 6, 0, /* ospfExternLSACount */ 
      1, 3, 6, 1, 2, 1, 14, 1, 7, 0, /* ospfExternLSACksumSum */ 
      1, 3, 6, 1, 2, 1, 14, 1, 8, 0, /* ospfTOSSupport */ 
      1, 3, 6, 1, 2, 1, 14, 1, 9, 0, /* ospfOriginateNewLSAs */ 
      1, 3, 6, 1, 2, 1, 14, 1, 10, 0, /* ospfRxNewLSAs */ 
      1, 3, 6, 1, 2, 1, 14, 2, 0, /* ospfAreaTable */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 0, /* ospfAreaEntry */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 1, 0, /* ospfAreaId */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 2, 0, /* ospfAuthType */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 3, 0, /* ospfImportASExtern */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 4, 0, /* ospfSpfRuns */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 5, 0, /* ospfAreaBdrRtrCount */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 6, 0, /* ospfASBdrRtrCount */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 7, 0, /* ospfAreaLSACount */ 
      1, 3, 6, 1, 2, 1, 14, 2, 1, 8, 0, /* ospfAreaLSACksumSum */ 
      1, 3, 6, 1, 2, 1, 14, 3, 0, /* ospfStubAreaTable */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 0, /* ospfStubAreaEntry */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 1, 0, /* ospfStubAreaID */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 2, 0, /* ospfStubTOS */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 3, 0, /* ospfStubMetric */ 
      1, 3, 6, 1, 2, 1, 14, 3, 1, 4, 0, /* ospfStubStatus */ 
      1, 3, 6, 1, 2, 1, 14, 4, 0, /* ospfLsdbTable */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 0, /* ospfLsdbEntry */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 1, 0, /* ospfLsdbAreaId */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 2, 0, /* ospfLsdbType */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 3, 0, /* ospfLsdbLSID */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 4, 0, /* ospfLsdbRouterId */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 5, 0, /* ospfLsdbSequence */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 6, 0, /* ospfLsdbAge */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 7, 0, /* ospfLsdbChecksum */ 
      1, 3, 6, 1, 2, 1, 14, 4, 1, 8, 0, /* ospfLsdbAdvertisement */ 
      1, 3, 6, 1, 2, 1, 14, 5, 0, /* ospfAreaRangeTable */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 0, /* ospfAreaRangeEntry */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 1, 0, /* ospfAreaRangeAreaID */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 2, 0, /* ospfAreaRangeNet */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 3, 0, /* ospfAreaRangeMask */ 
      1, 3, 6, 1, 2, 1, 14, 5, 1, 4, 0, /* ospfAreaRangeStatus */ 
      1, 3, 6, 1, 2, 1, 14, 6, 0, /* ospfHostTable */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 0, /* ospfHostEntry */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 1, 0, /* ospfHostIpAddress */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 2, 0, /* ospfHostTOS */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 3, 0, /* ospfHostMetric */ 
      1, 3, 6, 1, 2, 1, 14, 6, 1, 4, 0, /* ospfHostStatus */ 
      1, 3, 6, 1, 2, 1, 14, 7, 0, /* ospfIfTable */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 0, /* ospfIfEntry */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 1, 0, /* ospfIfIpAddress */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 2, 0, /* ospfAddressLessIf */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 3, 0, /* ospfIfAreaId */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 4, 0, /* ospfIfType */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 5, 0, /* ospfIfAdminStat */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 6, 0, /* ospfIfRtrPriority */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 7, 0, /* ospfIfTransitDelay */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 8, 0, /* ospfIfRetransInterval */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 9, 0, /* ospfIfHelloInterval */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 10, 0, /* ospfIfRtrDeadInterval */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 11, 0, /* ospfIfPollInterval */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 12, 0, /* ospfIfState */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 13, 0, /* ospfIfDesignatedRouter */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 14, 0, /* ospfIfBackupDesignatedRouter */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 15, 0, /* ospfIfEvents */ 
      1, 3, 6, 1, 2, 1, 14, 7, 1, 16, 0, /* ospfIfAuthKey */ 
      1, 3, 6, 1, 2, 1, 14, 8, 0, /* ospfIfMetricTable */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 0, /* ospfIfMetricEntry */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 1, 0, /* ospfIfMetricIpAddress */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 2, 0, /* ospfIfMetricAddressLessIf */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 3, 0, /* ospfIfMetricTOS */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 4, 0, /* ospfIfMetricMetric */ 
      1, 3, 6, 1, 2, 1, 14, 8, 1, 5, 0, /* ospfIfMetricStatus */ 
      1, 3, 6, 1, 2, 1, 14, 9, 0, /* ospfVirtIfTable */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 0, /* ospfVirtIfEntry */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 1, 0, /* ospfVirtIfAreaID */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 2, 0, /* ospfVirtIfNeighbor */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 3, 0, /* ospfVirtIfTransitDelay */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 4, 0, /* ospfVirtIfRetransInterval */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 5, 0, /* ospfVirtIfHelloInterval */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 6, 0, /* ospfVirtIfRtrDeadInterval */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 7, 0, /* ospfVirtIfState */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 8, 0, /* ospfVirtIfEvents */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 9, 0, /* ospfVirtIfAuthKey */ 
      1, 3, 6, 1, 2, 1, 14, 9, 1, 10, 0, /* ospfVirtIfStatus */ 
      1, 3, 6, 1, 2, 1, 14, 10, 0, /* ospfNbrTable */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 0, /* ospfNbrEntry */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 1, 0, /* ospfNbrIpAddr */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 2, 0, /* ospfNbrAddressLessIndex */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 3, 0, /* ospfNbrRtrId */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 4, 0, /* ospfNbrOptions */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 5, 0, /* ospfNbrPriority */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 6, 0, /* ospfNbrState */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 7, 0, /* ospfNbrEvents */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 8, 0, /* ospfNbrLSRetransQLen */ 
      1, 3, 6, 1, 2, 1, 14, 10, 1, 9, 0, /* ospfNBMANbrStatus */ 
      1, 3, 6, 1, 2, 1, 14, 11, 0, /* ospfVirtNbrTable */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 0, /* ospfVirtNbrEntry */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 1, 0, /* ospfVirtNbrArea */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 2, 0, /* ospfVirtNbrRtrId */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 3, 0, /* ospfVirtNbrIpAddr */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 4, 0, /* ospfVirtNbrOptions */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 5, 0, /* ospfVirtNbrState */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 6, 0, /* ospfVirtNbrEvents */ 
      1, 3, 6, 1, 2, 1, 14, 11, 1, 7, 0, /* ospfVirtNbrLSRetransQLen */ 
      1, 3, 6, 1, 2, 1, 15, 0, /* bgp */ 
      1, 3, 6, 1, 2, 1, 15, 1, 0, /* bgpVersion */ 
      1, 3, 6, 1, 2, 1, 15, 2, 0, /* bgpLocalAs */ 
      1, 3, 6, 1, 2, 1, 15, 3, 0, /* bgpPeerTable */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 0, /* bgpPeerEntry */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 1, 0, /* bgpPeerIdentifier */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 2, 0, /* bgpPeerState */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 3, 0, /* bgpPeerAdminStatus */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 4, 0, /* bgpPeerNegotiatedVersion */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 5, 0, /* bgpPeerLocalAddr */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 6, 0, /* bgpPeerLocalPort */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 7, 0, /* bgpPeerRemoteAddr */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 8, 0, /* bgpPeerRemotePort */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 9, 0, /* bgpPeerRemoteAs */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 10, 0, /* bgpPeerInUpdates */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 11, 0, /* bgpPeerOutUpdates */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 12, 0, /* bgpPeerInTotalMessages */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 13, 0, /* bgpPeerOutTotalMessages */ 
      1, 3, 6, 1, 2, 1, 15, 3, 1, 14, 0, /* bgpPeerLastError */ 
      1, 3, 6, 1, 2, 1, 15, 4, 0, /* bgpIdentifier */ 
      1, 3, 6, 1, 2, 1, 15, 5, 0, /* bgpRcvdPathAttrTable */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 0, /* bgpPathAttrEntry */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 1, 0, /* bgpPathAttrPeer */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 2, 0, /* bgpPathAttrDestNetwork */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 3, 0, /* bgpPathAttrOrigin */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 4, 0, /* bgpPathAttrASPath */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 5, 0, /* bgpPathAttrNextHop */ 
      1, 3, 6, 1, 2, 1, 15, 5, 1, 6, 0, /* bgpPathAttrInterASMetric */ 
      1, 3, 6, 1, 2, 1, 23, 0, /* rip2 */ 
      1, 3, 6, 1, 2, 1, 23, 1, 0, /* rip2GlobalGroup */ 
      1, 3, 6, 1, 2, 1, 23, 1, 1, 0, /* rip2GlobalRouteChanges */ 
      1, 3, 6, 1, 2, 1, 23, 1, 2, 0, /* rip2GlobalQueries */ 
      1, 3, 6, 1, 2, 1, 23, 2, 0, /* rip2IfStatTable */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 0, /* rip2IfStatEntry */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 1, 0, /* rip2IfStatAddress */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 2, 0, /* rip2IfStatRcvBadPackets */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 3, 0, /* rip2IfStatRcvBadRoutes */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 4, 0, /* rip2IfStatSentUpdates */ 
      1, 3, 6, 1, 2, 1, 23, 2, 1, 5, 0, /* rip2IfStatStatus */ 
      1, 3, 6, 1, 2, 1, 23, 3, 0, /* rip2IfConfTable */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 0, /* rip2IfConfEntry */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 1, 0, /* rip2IfConfAddress */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 2, 0, /* rip2IfConfDomain */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 3, 0, /* rip2IfConfAuthType */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 4, 0, /* rip2IfConfAuthKey */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 5, 0, /* rip2IfConfSend */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 6, 0, /* rip2IfConfReceive */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 7, 0, /* rip2IfConfDefaultMetric */ 
      1, 3, 6, 1, 2, 1, 23, 3, 1, 8, 0, /* rip2IfConfStatus */ 
      1, 3, 6, 1, 2, 1, 23, 4, 0, /* rip2PeerTable */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 0, /* rip2PeerEntry */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 1, 0, /* rip2PeerAddress */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 2, 0, /* rip2PeerDomain */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 3, 0, /* rip2PeerLastUpdate */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 4, 0, /* rip2PeerVersion */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 5, 0, /* rip2PeerRcvBadPackets */ 
      1, 3, 6, 1, 2, 1, 23, 4, 1, 6, 0, /* rip2PeerRcvBadRoutes */ 
      1, 3, 6, 1, 3, 0, /* experimental */ 
      1, 3, 6, 1, 3, 11, 0, /* view */ 
      1, 3, 6, 1, 3, 11, 1, 0, /* viewPrimTable */ 
      1, 3, 6, 1, 3, 11, 1, 1, 0, /* viewPrimEntry */ 
      1, 3, 6, 1, 3, 11, 1, 1, 1, 0, /* viewPrimName */ 
      1, 3, 6, 1, 3, 11, 1, 1, 2, 0, /* viewPrimTDomain */ 
      1, 3, 6, 1, 3, 11, 1, 1, 3, 0, /* viewPrimTAddr */ 
      1, 3, 6, 1, 3, 11, 1, 1, 4, 0, /* viewPrimUser */ 
      1, 3, 6, 1, 3, 11, 1, 1, 5, 0, /* viewPrimCommunity */ 
      1, 3, 6, 1, 3, 11, 1, 1, 6, 0, /* viewPrimType */ 
      1, 3, 6, 1, 3, 11, 2, 0, /* defaultView */ 
      1, 3, 6, 1, 3, 11, 2, 1, 0, /* defViewWholeRW */ 
      1, 3, 6, 1, 3, 11, 2, 2, 0, /* defViewWholeRO */ 
      1, 3, 6, 1, 3, 11, 2, 3, 0, /* defViewStandardRW */ 
      1, 3, 6, 1, 3, 11, 2, 4, 0, /* defViewStandardRO */ 
      1, 3, 6, 1, 3, 11, 2, 5, 0, /* defViewTrapDest */ 
      1, 3, 6, 1, 3, 11, 3, 0, /* viewDomains */ 
      1, 3, 6, 1, 3, 11, 3, 1, 0, /* snmpDomain */ 
      1, 3, 6, 1, 3, 11, 3, 1, 1, 0, /* rfc1157Domain */ 
      1, 3, 6, 1, 3, 11, 3, 1, 3, 0, /* cltsDomain */ 
      1, 3, 6, 1, 3, 11, 3, 1, 4, 0, /* cotsNDomain */ 
      1, 3, 6, 1, 3, 11, 3, 1, 5, 0, /* cotsXDomain */ 
      1, 3, 6, 1, 3, 11, 4, 0, /* viewAclTable */ 
      1, 3, 6, 1, 3, 11, 4, 1, 0, /* viewAclEntry */ 
      1, 3, 6, 1, 3, 11, 4, 1, 1, 0, /* viewAclView */ 
      1, 3, 6, 1, 3, 11, 4, 1, 2, 0, /* viewAclCommunity */ 
      1, 3, 6, 1, 3, 11, 4, 1, 3, 0, /* viewAclUser */ 
      1, 3, 6, 1, 3, 11, 4, 1, 4, 0, /* viewAclPrivileges */ 
      1, 3, 6, 1, 3, 11, 4, 1, 5, 0, /* viewAclType */ 
      1, 3, 6, 1, 3, 11, 5, 0, /* viewTrapTable */ 
      1, 3, 6, 1, 3, 11, 5, 1, 0, /* viewTrapEntry */ 
      1, 3, 6, 1, 3, 11, 5, 1, 1, 0, /* viewTrapView */ 
      1, 3, 6, 1, 3, 11, 5, 1, 2, 0, /* viewTrapGenerics */ 
      1, 3, 6, 1, 3, 11, 5, 1, 3, 0, /* viewTrapSpecifics */ 
      1, 3, 6, 1, 3, 11, 5, 1, 4, 0, /* viewTrapType */ 
      1, 3, 6, 1, 3, 11, 6, 0, /* viewTranTable */ 
      1, 3, 6, 1, 3, 11, 6, 1, 0, /* viewTranEntry */ 
      1, 3, 6, 1, 3, 11, 6, 1, 1, 0, /* viewSourceName */ 
      1, 3, 6, 1, 3, 11, 6, 1, 2, 0, /* viewSourceSubtree */ 
      1, 3, 6, 1, 3, 11, 6, 1, 3, 0, /* viewTargetName */ 
      1, 3, 6, 1, 3, 11, 6, 1, 4, 0, /* viewTargetSubtree */ 
      1, 3, 6, 1, 3, 11, 6, 1, 5, 0, /* viewTranType */ 
      1, 3, 6, 1, 4, 0, /* private */ 
      1, 3, 6, 1, 4, 1, 0, /* enterprises */ 
      1, 3, 6, 1, 4, 1, 4, 0, /* unix */ 
      1, 3, 6, 1, 4, 1, 4, 1, 0, /* agents */ 
      1, 3, 6, 1, 4, 1, 4, 1, 2, 0, /* fourBSD-isode */ 
      1, 3, 6, 1, 4, 1, 4, 1, 3, 0, /* agentAction */ 
      1, 3, 6, 1, 4, 1, 4, 2, 0, /* mbuf */ 
      1, 3, 6, 1, 4, 1, 4, 2, 1, 0, /* mbufs */ 
      1, 3, 6, 1, 4, 1, 4, 2, 2, 0, /* mbufClusters */ 
      1, 3, 6, 1, 4, 1, 4, 2, 3, 0, /* mbufFreeClusters */ 
      1, 3, 6, 1, 4, 1, 4, 2, 4, 0, /* mbufDrops */ 
      1, 3, 6, 1, 4, 1, 4, 2, 5, 0, /* mbufWaits */ 
      1, 3, 6, 1, 4, 1, 4, 2, 6, 0, /* mbufDrains */ 
      1, 3, 6, 1, 4, 1, 4, 2, 7, 0, /* mbufFrees */ 
      1, 3, 6, 1, 4, 1, 4, 2, 8, 0, /* mbufTable */ 
      1, 3, 6, 1, 4, 1, 4, 2, 8, 1, 0, /* mbufEntry */ 
      1, 3, 6, 1, 4, 1, 4, 2, 8, 1, 1, 0, /* mbufType */ 
      1, 3, 6, 1, 4, 1, 4, 2, 8, 1, 2, 0, /* mbufAllocates */ 
      1, 3, 6, 1, 4, 1, 4, 2, 9, 0, /* mbufSpaces */ 
      1, 3, 6, 1, 4, 1, 4, 3, 0, /* peers */ 
      1, 3, 6, 1, 4, 1, 4, 3, 1, 0, /* unixd */ 
      1, 3, 6, 1, 4, 1, 4, 4, 0, /* smux */ 
      1, 3, 6, 1, 4, 1, 4, 4, 1, 0, /* smuxPeerTable */ 
      1, 3, 6, 1, 4, 1, 4, 4, 1, 1, 0, /* smuxPeerEntry */ 
      1, 3, 6, 1, 4, 1, 4, 4, 1, 1, 1, 0, /* smuxPindex */ 
      1, 3, 6, 1, 4, 1, 4, 4, 1, 1, 2, 0, /* smuxPidentity */ 
      1, 3, 6, 1, 4, 1, 4, 4, 1, 1, 3, 0, /* smuxPdescription */ 
      1, 3, 6, 1, 4, 1, 4, 4, 1, 1, 4, 0, /* smuxPstatus */ 
      1, 3, 6, 1, 4, 1, 4, 4, 2, 0, /* smuxTreeTable */ 
      1, 3, 6, 1, 4, 1, 4, 4, 2, 1, 0, /* smuxTreeEntry */ 
      1, 3, 6, 1, 4, 1, 4, 4, 2, 1, 1, 0, /* smuxTsubtree */ 
      1, 3, 6, 1, 4, 1, 4, 4, 2, 1, 2, 0, /* smuxTpriority */ 
      1, 3, 6, 1, 4, 1, 4, 4, 2, 1, 3, 0, /* smuxTindex */ 
      1, 3, 6, 1, 4, 1, 4, 4, 2, 1, 4, 0, /* smuxTstatus */ 
      1, 3, 6, 1, 4, 1, 4, 5, 0, /* netstat */ 
      1, 3, 6, 1, 4, 1, 4, 5, 1, 0, /* unixNetstat */ 
      1, 3, 6, 1, 4, 1, 4, 5, 2, 0, /* unixTcpConnTable */ 
      1, 3, 6, 1, 4, 1, 4, 5, 2, 1, 0, /* unixTcpConnEntry */ 
      1, 3, 6, 1, 4, 1, 4, 5, 2, 1, 1, 0, /* unixTcpConnSendQ */ 
      1, 3, 6, 1, 4, 1, 4, 5, 2, 1, 2, 0, /* unixTcpConnRecvQ */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 0, /* unixUdpTable */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 0, /* unixUdpEntry */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 1, 0, /* unixUdpRemAddress */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 2, 0, /* unixUdpRemPort */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 3, 0, /* unixUdpSendQ */ 
      1, 3, 6, 1, 4, 1, 4, 5, 3, 1, 4, 0, /* unixUdpRecvQ */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 0, /* unixIpRoutingTable */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 1, 0, /* unixIpRouteEntry */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 1, 1, 0, /* unixIpRouteFlags */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 1, 2, 0, /* unixIpRouteRefCnt */ 
      1, 3, 6, 1, 4, 1, 4, 5, 4, 1, 3, 0, /* unixIpRouteUses */ 
      1, 3, 6, 1, 4, 1, 4, 5, 5, 0, /* unixRouteBadRedirects */ 
      1, 3, 6, 1, 4, 1, 4, 5, 6, 0, /* unixRouteCreatedByRedirects */ 
      1, 3, 6, 1, 4, 1, 4, 5, 7, 0, /* unixRouteModifiedByRedirects */ 
      1, 3, 6, 1, 4, 1, 4, 5, 8, 0, /* unixRouteLookupFails */ 
      1, 3, 6, 1, 4, 1, 4, 5, 9, 0, /* unixRouteWildcardUses */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 0, /* unixClnpRoutingTable */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 1, 0, /* unixClnpRouteEntry */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 1, 1, 0, /* unixClnpRouteFlags */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 1, 2, 0, /* unixClnpRouteRefCnt */ 
      1, 3, 6, 1, 4, 1, 4, 5, 10, 1, 3, 0, /* unixClnpRouteUses */ 
      1, 3, 6, 1, 4, 1, 4, 6, 0, /* print */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 0, /* printQTable */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 0, /* printQEntry */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 1, 0, /* printQName */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 2, 0, /* printQStatus */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 3, 0, /* printQDisplay */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 4, 0, /* printQEntries */ 
      1, 3, 6, 1, 4, 1, 4, 6, 1, 1, 5, 0, /* printQAction */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 0, /* printJTable */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 0, /* printJEntry */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 1, 0, /* printJRank */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 2, 0, /* printJName */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 3, 0, /* printJOwner */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 4, 0, /* printJDescription */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 5, 0, /* printJSize */ 
      1, 3, 6, 1, 4, 1, 4, 6, 2, 1, 6, 0, /* printJAction */ 
      1, 3, 6, 1, 4, 1, 4, 7, 0, /* users */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 0, /* userTable */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 0, /* userEntry */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 1, 0, /* userName */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 2, 0, /* userPasswd */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 3, 0, /* userID */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 4, 0, /* userGroup */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 5, 0, /* userQuota */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 6, 0, /* userComment */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 7, 0, /* userFullName */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 8, 0, /* userHome */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 9, 0, /* userShell */ 
      1, 3, 6, 1, 4, 1, 4, 7, 1, 1, 10, 0, /* userStatus */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 0, /* groupTable */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 0, /* groupEntry */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 1, 0, /* groupName */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 2, 0, /* groupPasswd */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 3, 0, /* groupID */ 
      1, 3, 6, 1, 4, 1, 4, 7, 2, 1, 4, 0, /* groupStatus */ 
      1, 3, 6, 1, 4, 1, 4, 7, 3, 0, /* grUserTable */ 
      1, 3, 6, 1, 4, 1, 4, 7, 3, 1, 0, /* grUserEntry */ 
      1, 3, 6, 1, 4, 1, 4, 7, 3, 1, 1, 0, /* grUserStatus */ 
      1, 3, 6, 1, 4, 1, 4, 8, 0, /* unixFs */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 0, /* fsTable */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 0, /* fsTableEntry */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 1, 0, /* fsIdentifier */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 2, 0, /* fsName */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 3, 0, /* fsMountPoint */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 4, 0, /* fsMountType */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 5, 0, /* fsMountOptions */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 6, 0, /* fsBlockSize */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 7, 0, /* fsBlockCount */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 8, 0, /* fsBlocksFree */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 9, 0, /* fsBlocksAvailable */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 10, 0, /* fsInodeCount */ 
      1, 3, 6, 1, 4, 1, 4, 8, 1, 1, 11, 0, /* fsInodesAvailable */ 
      1, 3, 6, 1, 4, 1, 99, 0, /* snmpResearch */ 
      1, 3, 6, 1, 4, 1, 99, 3, 0, /* functions */ 
      1, 3, 6, 1, 4, 1, 99, 3, 1, 0, /* functAdd */ 
      1, 3, 6, 1, 4, 1, 99, 3, 2, 0, /* functSub */ 
      1, 3, 6, 1, 4, 1, 99, 3, 3, 0, /* functMul */ 
      1, 3, 6, 1, 4, 1, 99, 3, 4, 0, /* functDiv */ 
      1, 3, 6, 1, 4, 1, 99, 3, 5, 0, /* functMod */ 
      1, 3, 6, 1, 4, 1, 99, 3, 6, 0, /* functNeg */ 
      1, 3, 6, 1, 4, 1, 99, 3, 7, 0, /* functXch */ 
      1, 3, 6, 1, 4, 1, 99, 3, 8, 0, /* functClr */ 
      1, 3, 6, 1, 4, 1, 99, 3, 9, 0, /* functDup */ 
      1, 3, 6, 1, 4, 1, 99, 3, 10, 0, /* functPop */ 
      1, 3, 6, 1, 4, 1, 99, 3, 11, 0, /* functAbs */ 
      1, 3, 6, 1, 4, 1, 99, 3, 12, 0, /* functSgn */ 
      1, 3, 6, 1, 4, 1, 99, 3, 13, 0, /* functMin */ 
      1, 3, 6, 1, 4, 1, 99, 3, 14, 0, /* functAnd */ 
      1, 3, 6, 1, 4, 1, 99, 3, 15, 0, /* functOr */ 
      1, 3, 6, 1, 4, 1, 99, 3, 16, 0, /* functNot */ 
      1, 3, 6, 1, 4, 1, 99, 4, 0, /* expressions */ 
      1, 3, 6, 1, 4, 1, 99, 4, 1, 0, /* exprNumber */ 
      1, 3, 6, 1, 4, 1, 99, 4, 2, 0, /* exprTable */ 
      1, 3, 6, 1, 4, 1, 99, 4, 2, 1, 0, /* exprEntry */ 
      1, 3, 6, 1, 4, 1, 99, 4, 2, 1, 1, 0, /* exprIndex */ 
      1, 3, 6, 1, 4, 1, 99, 4, 2, 1, 2, 0, /* exprEval */ 
      1, 3, 6, 1, 4, 1, 99, 4, 2, 1, 3, 0, /* exprExpr */ 
      1, 3, 6, 1, 4, 1, 99, 4, 2, 1, 4, 0, /* exprStatus */ 
      1, 3, 6, 1, 4, 1, 99, 4, 2, 1, 5, 0, /* exprHints */ 
      2, 0, /* joint-iso-ccitt */ 
};

static OIDentifier _names[] = {
    { 1, &_elems[0] }, 
    { 2, &_elems[2] }, 
    { 1, &_elems[5] }, 
    { 4, &_elems[7] }, 
    { 5, &_elems[12] }, 
    { 5, &_elems[18] }, 
    { 6, &_elems[24] }, 
    { 7, &_elems[31] }, 
    { 8, &_elems[39] }, 
    { 8, &_elems[48] }, 
    { 8, &_elems[57] }, 
    { 8, &_elems[66] }, 
    { 8, &_elems[75] }, 
    { 8, &_elems[84] }, 
    { 8, &_elems[93] }, 
    { 7, &_elems[102] }, 
    { 8, &_elems[110] }, 
    { 8, &_elems[119] }, 
    { 9, &_elems[128] }, 
    { 10, &_elems[138] }, 
    { 10, &_elems[149] }, 
    { 10, &_elems[160] }, 
    { 10, &_elems[171] }, 
    { 10, &_elems[182] }, 
    { 10, &_elems[193] }, 
    { 10, &_elems[204] }, 
    { 10, &_elems[215] }, 
    { 10, &_elems[226] }, 
    { 10, &_elems[237] }, 
    { 10, &_elems[248] }, 
    { 10, &_elems[259] }, 
    { 10, &_elems[270] }, 
    { 10, &_elems[281] }, 
    { 10, &_elems[292] }, 
    { 10, &_elems[303] }, 
    { 10, &_elems[314] }, 
    { 10, &_elems[325] }, 
    { 10, &_elems[336] }, 
    { 10, &_elems[347] }, 
    { 10, &_elems[358] }, 
    { 10, &_elems[369] }, 
    { 7, &_elems[380] }, 
    { 8, &_elems[388] }, 
    { 9, &_elems[397] }, 
    { 10, &_elems[407] }, 
    { 10, &_elems[418] }, 
    { 10, &_elems[429] }, 
    { 7, &_elems[440] }, 
    { 8, &_elems[448] }, 
    { 8, &_elems[457] }, 
    { 8, &_elems[466] }, 
    { 8, &_elems[475] }, 
    { 8, &_elems[484] }, 
    { 8, &_elems[493] }, 
    { 8, &_elems[502] }, 
    { 8, &_elems[511] }, 
    { 8, &_elems[520] }, 
    { 8, &_elems[529] }, 
    { 8, &_elems[538] }, 
    { 8, &_elems[547] }, 
    { 8, &_elems[556] }, 
    { 8, &_elems[565] }, 
    { 8, &_elems[574] }, 
    { 8, &_elems[583] }, 
    { 8, &_elems[592] }, 
    { 8, &_elems[601] }, 
    { 8, &_elems[610] }, 
    { 8, &_elems[619] }, 
    { 9, &_elems[628] }, 
    { 10, &_elems[638] }, 
    { 10, &_elems[649] }, 
    { 10, &_elems[660] }, 
    { 10, &_elems[671] }, 
    { 10, &_elems[682] }, 
    { 8, &_elems[693] }, 
    { 9, &_elems[702] }, 
    { 10, &_elems[712] }, 
    { 10, &_elems[723] }, 
    { 10, &_elems[734] }, 
    { 10, &_elems[745] }, 
    { 10, &_elems[756] }, 
    { 10, &_elems[767] }, 
    { 10, &_elems[778] }, 
    { 10, &_elems[789] }, 
    { 10, &_elems[800] }, 
    { 10, &_elems[811] }, 
    { 10, &_elems[822] }, 
    { 10, &_elems[833] }, 
    { 10, &_elems[844] }, 
    { 8, &_elems[855] }, 
    { 9, &_elems[864] }, 
    { 10, &_elems[874] }, 
    { 10, &_elems[885] }, 
    { 10, &_elems[896] }, 
    { 10, &_elems[907] }, 
    { 8, &_elems[918] }, 
    { 8, &_elems[927] }, 
    { 9, &_elems[936] }, 
    { 9, &_elems[946] }, 
    { 10, &_elems[956] }, 
    { 11, &_elems[967] }, 
    { 11, &_elems[979] }, 
    { 11, &_elems[991] }, 
    { 11, &_elems[1003] }, 
    { 11, &_elems[1015] }, 
    { 11, &_elems[1027] }, 
    { 11, &_elems[1039] }, 
    { 11, &_elems[1051] }, 
    { 11, &_elems[1063] }, 
    { 11, &_elems[1075] }, 
    { 11, &_elems[1087] }, 
    { 11, &_elems[1099] }, 
    { 11, &_elems[1111] }, 
    { 11, &_elems[1123] }, 
    { 11, &_elems[1135] }, 
    { 7, &_elems[1147] }, 
    { 8, &_elems[1155] }, 
    { 8, &_elems[1164] }, 
    { 8, &_elems[1173] }, 
    { 8, &_elems[1182] }, 
    { 8, &_elems[1191] }, 
    { 8, &_elems[1200] }, 
    { 8, &_elems[1209] }, 
    { 8, &_elems[1218] }, 
    { 8, &_elems[1227] }, 
    { 8, &_elems[1236] }, 
    { 8, &_elems[1245] }, 
    { 8, &_elems[1254] }, 
    { 8, &_elems[1263] }, 
    { 8, &_elems[1272] }, 
    { 8, &_elems[1281] }, 
    { 8, &_elems[1290] }, 
    { 8, &_elems[1299] }, 
    { 8, &_elems[1308] }, 
    { 8, &_elems[1317] }, 
    { 8, &_elems[1326] }, 
    { 8, &_elems[1335] }, 
    { 8, &_elems[1344] }, 
    { 8, &_elems[1353] }, 
    { 8, &_elems[1362] }, 
    { 8, &_elems[1371] }, 
    { 8, &_elems[1380] }, 
    { 7, &_elems[1389] }, 
    { 8, &_elems[1397] }, 
    { 8, &_elems[1406] }, 
    { 8, &_elems[1415] }, 
    { 8, &_elems[1424] }, 
    { 8, &_elems[1433] }, 
    { 8, &_elems[1442] }, 
    { 8, &_elems[1451] }, 
    { 8, &_elems[1460] }, 
    { 8, &_elems[1469] }, 
    { 8, &_elems[1478] }, 
    { 8, &_elems[1487] }, 
    { 8, &_elems[1496] }, 
    { 8, &_elems[1505] }, 
    { 9, &_elems[1514] }, 
    { 10, &_elems[1524] }, 
    { 10, &_elems[1535] }, 
    { 10, &_elems[1546] }, 
    { 10, &_elems[1557] }, 
    { 10, &_elems[1568] }, 
    { 8, &_elems[1579] }, 
    { 8, &_elems[1588] }, 
    { 7, &_elems[1597] }, 
    { 8, &_elems[1605] }, 
    { 8, &_elems[1614] }, 
    { 8, &_elems[1623] }, 
    { 8, &_elems[1632] }, 
    { 8, &_elems[1641] }, 
    { 9, &_elems[1650] }, 
    { 10, &_elems[1660] }, 
    { 10, &_elems[1671] }, 
    { 7, &_elems[1682] }, 
    { 8, &_elems[1690] }, 
    { 8, &_elems[1699] }, 
    { 8, &_elems[1708] }, 
    { 8, &_elems[1717] }, 
    { 8, &_elems[1726] }, 
    { 9, &_elems[1735] }, 
    { 10, &_elems[1745] }, 
    { 10, &_elems[1756] }, 
    { 10, &_elems[1767] }, 
    { 10, &_elems[1778] }, 
    { 10, &_elems[1789] }, 
    { 10, &_elems[1800] }, 
    { 10, &_elems[1811] }, 
    { 10, &_elems[1822] }, 
    { 10, &_elems[1833] }, 
    { 10, &_elems[1844] }, 
    { 10, &_elems[1855] }, 
    { 10, &_elems[1866] }, 
    { 10, &_elems[1877] }, 
    { 10, &_elems[1888] }, 
    { 10, &_elems[1899] }, 
    { 8, &_elems[1910] }, 
    { 7, &_elems[1919] }, 
    { 7, &_elems[1927] }, 
    { 8, &_elems[1935] }, 
    { 8, &_elems[1944] }, 
    { 8, &_elems[1953] }, 
    { 8, &_elems[1962] }, 
    { 8, &_elems[1971] }, 
    { 8, &_elems[1980] }, 
    { 8, &_elems[1989] }, 
    { 8, &_elems[1998] }, 
    { 8, &_elems[2007] }, 
    { 8, &_elems[2016] }, 
    { 8, &_elems[2025] }, 
    { 8, &_elems[2034] }, 
    { 8, &_elems[2043] }, 
    { 8, &_elems[2052] }, 
    { 8, &_elems[2061] }, 
    { 8, &_elems[2070] }, 
    { 8, &_elems[2079] }, 
    { 8, &_elems[2088] }, 
    { 8, &_elems[2097] }, 
    { 8, &_elems[2106] }, 
    { 8, &_elems[2115] }, 
    { 8, &_elems[2124] }, 
    { 8, &_elems[2133] }, 
    { 8, &_elems[2142] }, 
    { 8, &_elems[2151] }, 
    { 8, &_elems[2160] }, 
    { 8, &_elems[2169] }, 
    { 8, &_elems[2178] }, 
    { 7, &_elems[2187] }, 
    { 8, &_elems[2195] }, 
    { 9, &_elems[2204] }, 
    { 9, &_elems[2214] }, 
    { 9, &_elems[2224] }, 
    { 9, &_elems[2234] }, 
    { 9, &_elems[2244] }, 
    { 9, &_elems[2254] }, 
    { 9, &_elems[2264] }, 
    { 9, &_elems[2274] }, 
    { 9, &_elems[2284] }, 
    { 9, &_elems[2294] }, 
    { 8, &_elems[2304] }, 
    { 9, &_elems[2313] }, 
    { 10, &_elems[2323] }, 
    { 10, &_elems[2334] }, 
    { 10, &_elems[2345] }, 
    { 10, &_elems[2356] }, 
    { 10, &_elems[2367] }, 
    { 10, &_elems[2378] }, 
    { 10, &_elems[2389] }, 
    { 10, &_elems[2400] }, 
    { 8, &_elems[2411] }, 
    { 9, &_elems[2420] }, 
    { 10, &_elems[2430] }, 
    { 10, &_elems[2441] }, 
    { 10, &_elems[2452] }, 
    { 10, &_elems[2463] }, 
    { 8, &_elems[2474] }, 
    { 9, &_elems[2483] }, 
    { 10, &_elems[2493] }, 
    { 10, &_elems[2504] }, 
    { 10, &_elems[2515] }, 
    { 10, &_elems[2526] }, 
    { 10, &_elems[2537] }, 
    { 10, &_elems[2548] }, 
    { 10, &_elems[2559] }, 
    { 10, &_elems[2570] }, 
    { 8, &_elems[2581] }, 
    { 9, &_elems[2590] }, 
    { 10, &_elems[2600] }, 
    { 10, &_elems[2611] }, 
    { 10, &_elems[2622] }, 
    { 10, &_elems[2633] }, 
    { 8, &_elems[2644] }, 
    { 9, &_elems[2653] }, 
    { 10, &_elems[2663] }, 
    { 10, &_elems[2674] }, 
    { 10, &_elems[2685] }, 
    { 10, &_elems[2696] }, 
    { 8, &_elems[2707] }, 
    { 9, &_elems[2716] }, 
    { 10, &_elems[2726] }, 
    { 10, &_elems[2737] }, 
    { 10, &_elems[2748] }, 
    { 10, &_elems[2759] }, 
    { 10, &_elems[2770] }, 
    { 10, &_elems[2781] }, 
    { 10, &_elems[2792] }, 
    { 10, &_elems[2803] }, 
    { 10, &_elems[2814] }, 
    { 10, &_elems[2825] }, 
    { 10, &_elems[2836] }, 
    { 10, &_elems[2847] }, 
    { 10, &_elems[2858] }, 
    { 10, &_elems[2869] }, 
    { 10, &_elems[2880] }, 
    { 10, &_elems[2891] }, 
    { 8, &_elems[2902] }, 
    { 9, &_elems[2911] }, 
    { 10, &_elems[2921] }, 
    { 10, &_elems[2932] }, 
    { 10, &_elems[2943] }, 
    { 10, &_elems[2954] }, 
    { 10, &_elems[2965] }, 
    { 8, &_elems[2976] }, 
    { 9, &_elems[2985] }, 
    { 10, &_elems[2995] }, 
    { 10, &_elems[3006] }, 
    { 10, &_elems[3017] }, 
    { 10, &_elems[3028] }, 
    { 10, &_elems[3039] }, 
    { 10, &_elems[3050] }, 
    { 10, &_elems[3061] }, 
    { 10, &_elems[3072] }, 
    { 10, &_elems[3083] }, 
    { 10, &_elems[3094] }, 
    { 8, &_elems[3105] }, 
    { 9, &_elems[3114] }, 
    { 10, &_elems[3124] }, 
    { 10, &_elems[3135] }, 
    { 10, &_elems[3146] }, 
    { 10, &_elems[3157] }, 
    { 10, &_elems[3168] }, 
    { 10, &_elems[3179] }, 
    { 10, &_elems[3190] }, 
    { 10, &_elems[3201] }, 
    { 10, &_elems[3212] }, 
    { 8, &_elems[3223] }, 
    { 9, &_elems[3232] }, 
    { 10, &_elems[3242] }, 
    { 10, &_elems[3253] }, 
    { 10, &_elems[3264] }, 
    { 10, &_elems[3275] }, 
    { 10, &_elems[3286] }, 
    { 10, &_elems[3297] }, 
    { 10, &_elems[3308] }, 
    { 7, &_elems[3319] }, 
    { 8, &_elems[3327] }, 
    { 8, &_elems[3336] }, 
    { 8, &_elems[3345] }, 
    { 9, &_elems[3354] }, 
    { 10, &_elems[3364] }, 
    { 10, &_elems[3375] }, 
    { 10, &_elems[3386] }, 
    { 10, &_elems[3397] }, 
    { 10, &_elems[3408] }, 
    { 10, &_elems[3419] }, 
    { 10, &_elems[3430] }, 
    { 10, &_elems[3441] }, 
    { 10, &_elems[3452] }, 
    { 10, &_elems[3463] }, 
    { 10, &_elems[3474] }, 
    { 10, &_elems[3485] }, 
    { 10, &_elems[3496] }, 
    { 10, &_elems[3507] }, 
    { 8, &_elems[3518] }, 
    { 8, &_elems[3527] }, 
    { 9, &_elems[3536] }, 
    { 10, &_elems[3546] }, 
    { 10, &_elems[3557] }, 
    { 10, &_elems[3568] }, 
    { 10, &_elems[3579] }, 
    { 10, &_elems[3590] }, 
    { 10, &_elems[3601] }, 
    { 7, &_elems[3612] }, 
    { 8, &_elems[3620] }, 
    { 9, &_elems[3629] }, 
    { 9, &_elems[3639] }, 
    { 8, &_elems[3649] }, 
    { 9, &_elems[3658] }, 
    { 10, &_elems[3668] }, 
    { 10, &_elems[3679] }, 
    { 10, &_elems[3690] }, 
    { 10, &_elems[3701] }, 
    { 10, &_elems[3712] }, 
    { 8, &_elems[3723] }, 
    { 9, &_elems[3732] }, 
    { 10, &_elems[3742] }, 
    { 10, &_elems[3753] }, 
    { 10, &_elems[3764] }, 
    { 10, &_elems[3775] }, 
    { 10, &_elems[3786] }, 
    { 10, &_elems[3797] }, 
    { 10, &_elems[3808] }, 
    { 10, &_elems[3819] }, 
    { 8, &_elems[3830] }, 
    { 9, &_elems[3839] }, 
    { 10, &_elems[3849] }, 
    { 10, &_elems[3860] }, 
    { 10, &_elems[3871] }, 
    { 10, &_elems[3882] }, 
    { 10, &_elems[3893] }, 
    { 10, &_elems[3904] }, 
    { 5, &_elems[3915] }, 
    { 6, &_elems[3921] }, 
    { 7, &_elems[3928] }, 
    { 8, &_elems[3936] }, 
    { 9, &_elems[3945] }, 
    { 9, &_elems[3955] }, 
    { 9, &_elems[3965] }, 
    { 9, &_elems[3975] }, 
    { 9, &_elems[3985] }, 
    { 9, &_elems[3995] }, 
    { 7, &_elems[4005] }, 
    { 8, &_elems[4013] }, 
    { 8, &_elems[4022] }, 
    { 8, &_elems[4031] }, 
    { 8, &_elems[4040] }, 
    { 8, &_elems[4049] }, 
    { 7, &_elems[4058] }, 
    { 8, &_elems[4066] }, 
    { 9, &_elems[4075] }, 
    { 9, &_elems[4085] }, 
    { 9, &_elems[4095] }, 
    { 9, &_elems[4105] }, 
    { 7, &_elems[4115] }, 
    { 8, &_elems[4123] }, 
    { 9, &_elems[4132] }, 
    { 9, &_elems[4142] }, 
    { 9, &_elems[4152] }, 
    { 9, &_elems[4162] }, 
    { 9, &_elems[4172] }, 
    { 7, &_elems[4182] }, 
    { 8, &_elems[4190] }, 
    { 9, &_elems[4199] }, 
    { 9, &_elems[4209] }, 
    { 9, &_elems[4219] }, 
    { 9, &_elems[4229] }, 
    { 7, &_elems[4239] }, 
    { 8, &_elems[4247] }, 
    { 9, &_elems[4256] }, 
    { 9, &_elems[4266] }, 
    { 9, &_elems[4276] }, 
    { 9, &_elems[4286] }, 
    { 9, &_elems[4296] }, 
    { 5, &_elems[4306] }, 
    { 6, &_elems[4312] }, 
    { 7, &_elems[4319] }, 
    { 8, &_elems[4327] }, 
    { 9, &_elems[4336] }, 
    { 9, &_elems[4346] }, 
    { 8, &_elems[4356] }, 
    { 9, &_elems[4365] }, 
    { 9, &_elems[4375] }, 
    { 9, &_elems[4385] }, 
    { 9, &_elems[4395] }, 
    { 9, &_elems[4405] }, 
    { 9, &_elems[4415] }, 
    { 9, &_elems[4425] }, 
    { 9, &_elems[4435] }, 
    { 10, &_elems[4445] }, 
    { 11, &_elems[4456] }, 
    { 11, &_elems[4468] }, 
    { 9, &_elems[4480] }, 
    { 8, &_elems[4490] }, 
    { 9, &_elems[4499] }, 
    { 8, &_elems[4509] }, 
    { 9, &_elems[4518] }, 
    { 10, &_elems[4528] }, 
    { 11, &_elems[4539] }, 
    { 11, &_elems[4551] }, 
    { 11, &_elems[4563] }, 
    { 11, &_elems[4575] }, 
    { 9, &_elems[4587] }, 
    { 10, &_elems[4597] }, 
    { 11, &_elems[4608] }, 
    { 11, &_elems[4620] }, 
    { 11, &_elems[4632] }, 
    { 11, &_elems[4644] }, 
    { 8, &_elems[4656] }, 
    { 9, &_elems[4665] }, 
    { 9, &_elems[4675] }, 
    { 10, &_elems[4685] }, 
    { 11, &_elems[4696] }, 
    { 11, &_elems[4708] }, 
    { 9, &_elems[4720] }, 
    { 10, &_elems[4730] }, 
    { 11, &_elems[4741] }, 
    { 11, &_elems[4753] }, 
    { 11, &_elems[4765] }, 
    { 11, &_elems[4777] }, 
    { 9, &_elems[4789] }, 
    { 10, &_elems[4799] }, 
    { 11, &_elems[4810] }, 
    { 11, &_elems[4822] }, 
    { 11, &_elems[4834] }, 
    { 9, &_elems[4846] }, 
    { 9, &_elems[4856] }, 
    { 9, &_elems[4866] }, 
    { 9, &_elems[4876] }, 
    { 9, &_elems[4886] }, 
    { 9, &_elems[4896] }, 
    { 10, &_elems[4906] }, 
    { 11, &_elems[4917] }, 
    { 11, &_elems[4929] }, 
    { 11, &_elems[4941] }, 
    { 8, &_elems[4953] }, 
    { 9, &_elems[4962] }, 
    { 10, &_elems[4972] }, 
    { 11, &_elems[4983] }, 
    { 11, &_elems[4995] }, 
    { 11, &_elems[5007] }, 
    { 11, &_elems[5019] }, 
    { 11, &_elems[5031] }, 
    { 9, &_elems[5043] }, 
    { 10, &_elems[5053] }, 
    { 11, &_elems[5064] }, 
    { 11, &_elems[5076] }, 
    { 11, &_elems[5088] }, 
    { 11, &_elems[5100] }, 
    { 11, &_elems[5112] }, 
    { 11, &_elems[5124] }, 
    { 8, &_elems[5136] }, 
    { 9, &_elems[5145] }, 
    { 10, &_elems[5155] }, 
    { 11, &_elems[5166] }, 
    { 11, &_elems[5178] }, 
    { 11, &_elems[5190] }, 
    { 11, &_elems[5202] }, 
    { 11, &_elems[5214] }, 
    { 11, &_elems[5226] }, 
    { 11, &_elems[5238] }, 
    { 11, &_elems[5250] }, 
    { 11, &_elems[5262] }, 
    { 11, &_elems[5274] }, 
    { 9, &_elems[5286] }, 
    { 10, &_elems[5296] }, 
    { 11, &_elems[5307] }, 
    { 11, &_elems[5319] }, 
    { 11, &_elems[5331] }, 
    { 11, &_elems[5343] }, 
    { 9, &_elems[5355] }, 
    { 10, &_elems[5365] }, 
    { 11, &_elems[5376] }, 
    { 8, &_elems[5388] }, 
    { 9, &_elems[5397] }, 
    { 10, &_elems[5407] }, 
    { 11, &_elems[5418] }, 
    { 11, &_elems[5430] }, 
    { 11, &_elems[5442] }, 
    { 11, &_elems[5454] }, 
    { 11, &_elems[5466] }, 
    { 11, &_elems[5478] }, 
    { 11, &_elems[5490] }, 
    { 11, &_elems[5502] }, 
    { 11, &_elems[5514] }, 
    { 11, &_elems[5526] }, 
    { 11, &_elems[5538] }, 
    { 7, &_elems[5550] }, 
    { 8, &_elems[5558] }, 
    { 9, &_elems[5567] }, 
    { 9, &_elems[5577] }, 
    { 9, &_elems[5587] }, 
    { 9, &_elems[5597] }, 
    { 9, &_elems[5607] }, 
    { 9, &_elems[5617] }, 
    { 9, &_elems[5627] }, 
    { 9, &_elems[5637] }, 
    { 9, &_elems[5647] }, 
    { 9, &_elems[5657] }, 
    { 9, &_elems[5667] }, 
    { 9, &_elems[5677] }, 
    { 9, &_elems[5687] }, 
    { 9, &_elems[5697] }, 
    { 9, &_elems[5707] }, 
    { 9, &_elems[5717] }, 
    { 8, &_elems[5727] }, 
    { 9, &_elems[5736] }, 
    { 9, &_elems[5746] }, 
    { 10, &_elems[5756] }, 
    { 11, &_elems[5767] }, 
    { 11, &_elems[5779] }, 
    { 11, &_elems[5791] }, 
    { 11, &_elems[5803] }, 
    { 11, &_elems[5815] }, 
    { 1, &_elems[5827] }, 
};

static struct _syntax {
    char   *name;
    OS      value;
}	_syntaxes[] = {
    { "INTEGER", NULLOS }, 
    { "Services", NULLOS }, 
    { "Privileges", NULLOS }, 
    { "OctetString", NULLOS }, 
    { "DisplayString", NULLOS }, 
    { "PhysAddress", NULLOS }, 
    { "ObjectID", NULLOS }, 
    { "NULL", NULLOS }, 
    { "IpAddress", NULLOS }, 
    { "NetworkAddress", NULLOS }, 
    { "Counter", NULLOS }, 
    { "Gauge", NULLOS }, 
    { "TimeTicks", NULLOS }, 
    { "ClnpAddress", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    { "INTEGER", NULLOS }, 
    NULL
};

static object_type _types[] = {
    { "ccitt", "0", &_names[0],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, NULLOT, &_types[1] },
    { "localAgent", "0.0", &_names[1],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[377], NULLOT, NULLOT, &_types[2] },
    { "iso", "1", &_names[2],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, &_types[3], &_types[3] },
    { "internet", "1.3.6.1", &_names[3],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, &_types[4], &_types[4] },
    { "directory", "1.3.6.1.1", &_names[4],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[432], NULLOT, &_types[5] },
    { "mgmt", "1.3.6.1.2", &_names[5],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, &_types[6], &_types[6] },
    { "mib-2", "1.3.6.1.2.1", &_names[6],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, &_types[196], &_types[7] },
    { "system", "1.3.6.1.2.1.1", &_names[7],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[4], &_types[226], &_types[9], &_types[8] },
    { "sysDescr", "1.3.6.1.2.1.1.1", &_names[8],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, NULLOT, &_types[9] },
    { "sysObjectID", "1.3.6.1.2.1.1.2", &_names[9],
      (OS) 6, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[572], &_types[11], NULLOT, &_types[10] },
    { "sysUpTime", "1.3.6.1.2.1.1.3", &_names[10],
      (OS) 12, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[8], NULLOT, &_types[11] },
    { "sysContact", "1.3.6.1.2.1.1.4", &_names[11],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[13], NULLOT, &_types[12] },
    { "sysName", "1.3.6.1.2.1.1.5", &_names[12],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[10], NULLOT, &_types[13] },
    { "sysLocation", "1.3.6.1.2.1.1.6", &_names[13],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[14], NULLOT, &_types[14] },
    { "sysServices", "1.3.6.1.2.1.1.7", &_names[14],
      (OS) 1, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[13], &_types[12], NULLOT, &_types[15] },
    { "interfaces", "1.3.6.1.2.1.2", &_names[15],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[3], &_types[173], &_types[16], &_types[16] },
    { "ifNumber", "1.3.6.1.2.1.2.1", &_names[16],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[17], NULLOT, &_types[17] },
    { "ifTable", "1.3.6.1.2.1.2.2", &_names[17],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, &_types[18], &_types[18] },
    { "ifEntry", "1.3.6.1.2.1.2.2.1", &_names[18],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[433], NULLOT, &_types[21], &_types[19] },
    { "ifIndex", "1.3.6.1.2.1.2.2.1.1", &_names[19],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[27], NULLOT, &_types[20] },
    { "ifDescr", "1.3.6.1.2.1.2.2.1.2", &_names[20],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[8], &_types[22], NULLOT, &_types[21] },
    { "ifType", "1.3.6.1.2.1.2.2.1.3", &_names[21],
      (OS) 14, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[18], &_types[32], NULLOT, &_types[22] },
    { "ifMtu", "1.3.6.1.2.1.2.2.1.4", &_names[22],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[173], &_types[31], NULLOT, &_types[23] },
    { "ifSpeed", "1.3.6.1.2.1.2.2.1.5", &_names[23],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[40], NULLOT, &_types[24] },
    { "ifPhysAddress", "1.3.6.1.2.1.2.2.1.6", &_names[24],
      (OS) 5, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[164], &_types[25], NULLOT, &_types[25] },
    { "ifAdminStatus", "1.3.6.1.2.1.2.2.1.7", &_names[25],
      (OS) 15, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[14], &_types[26], NULLOT, &_types[26] },
    { "ifOperStatus", "1.3.6.1.2.1.2.2.1.8", &_names[26],
      (OS) 16, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[25], &_types[28], NULLOT, &_types[27] },
    { "ifLastChange", "1.3.6.1.2.1.2.2.1.9", &_names[27],
      (OS) 12, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[29], NULLOT, &_types[28] },
    { "ifInOctets", "1.3.6.1.2.1.2.2.1.10", &_names[28],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[26], &_types[34], NULLOT, &_types[29] },
    { "ifInUcastPkts", "1.3.6.1.2.1.2.2.1.11", &_names[29],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[30], NULLOT, &_types[30] },
    { "ifInNUcastPkts", "1.3.6.1.2.1.2.2.1.12", &_names[30],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[29], &_types[35], NULLOT, &_types[31] },
    { "ifInDiscards", "1.3.6.1.2.1.2.2.1.13", &_names[31],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[22], &_types[37], NULLOT, &_types[32] },
    { "ifInErrors", "1.3.6.1.2.1.2.2.1.14", &_names[32],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[2], &_types[38], NULLOT, &_types[33] },
    { "ifInUnknownProtos", "1.3.6.1.2.1.2.2.1.15", &_names[33],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[7], NULLOT, NULLOT, &_types[34] },
    { "ifOutOctets", "1.3.6.1.2.1.2.2.1.16", &_names[34],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[28], &_types[19], NULLOT, &_types[35] },
    { "ifOutUcastPkts", "1.3.6.1.2.1.2.2.1.17", &_names[35],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[30], &_types[36], NULLOT, &_types[36] },
    { "ifOutNUcastPkts", "1.3.6.1.2.1.2.2.1.18", &_names[36],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[35], &_types[39], NULLOT, &_types[37] },
    { "ifOutDiscards", "1.3.6.1.2.1.2.2.1.19", &_names[37],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[31], &_types[33], NULLOT, &_types[38] },
    { "ifOutErrors", "1.3.6.1.2.1.2.2.1.20", &_names[38],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[32], &_types[24], NULLOT, &_types[39] },
    { "ifOutQLen", "1.3.6.1.2.1.2.2.1.21", &_names[39],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[17], &_types[23], NULLOT, &_types[40] },
    { "ifSpecific", "1.3.6.1.2.1.2.2.1.22", &_names[40],
      (OS) 6, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[23], &_types[20], NULLOT, &_types[41] },
    { "at", "1.3.6.1.2.1.3", &_names[41],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[15], &_types[42], &_types[42] },
    { "atTable", "1.3.6.1.2.1.3.1", &_names[42],
      (OS) -1, 0, (u_long) 0, 3,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[39], NULLOT, &_types[43], &_types[43] },
    { "atEntry", "1.3.6.1.2.1.3.1.1", &_names[43],
      (OS) -1, 0, (u_long) 0, 3,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[21], NULLOT, &_types[45], &_types[44] },
    { "atIfIndex", "1.3.6.1.2.1.3.1.1.1", &_names[44],
      (OS) 0, 3, (u_long) 0, 3,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[19], NULLOT, NULLOT, &_types[45] },
    { "atPhysAddress", "1.3.6.1.2.1.3.1.1.2", &_names[45],
      (OS) 5, 3, (u_long) 0, 3,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[24], &_types[46], NULLOT, &_types[46] },
    { "atNetAddress", "1.3.6.1.2.1.3.1.1.3", &_names[46],
      (OS) 9, 3, (u_long) 0, 3,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[45], &_types[44], NULLOT, &_types[47] },
    { "ip", "1.3.6.1.2.1.4", &_names[47],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[41], &_types[62], &_types[48] },
    { "ipForwarding", "1.3.6.1.2.1.4.1", &_names[48],
      (OS) 17, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[96], NULLOT, &_types[49] },
    { "ipDefaultTTL", "1.3.6.1.2.1.4.2", &_names[49],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[56], NULLOT, &_types[50] },
    { "ipInReceives", "1.3.6.1.2.1.4.3", &_names[50],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[63], NULLOT, &_types[51] },
    { "ipInHdrErrors", "1.3.6.1.2.1.4.4", &_names[51],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[38], &_types[52], NULLOT, &_types[52] },
    { "ipInAddrErrors", "1.3.6.1.2.1.4.5", &_names[52],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[51], &_types[57], NULLOT, &_types[53] },
    { "ipForwDatagrams", "1.3.6.1.2.1.4.6", &_names[53],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[66], NULLOT, &_types[54] },
    { "ipInUnknownProtos", "1.3.6.1.2.1.4.7", &_names[54],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[33], &_types[49], NULLOT, &_types[55] },
    { "ipInDiscards", "1.3.6.1.2.1.4.8", &_names[55],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[37], &_types[58], NULLOT, &_types[56] },
    { "ipInDelivers", "1.3.6.1.2.1.4.9", &_names[56],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[43], &_types[48], NULLOT, &_types[57] },
    { "ipOutRequests", "1.3.6.1.2.1.4.10", &_names[57],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[61], NULLOT, &_types[58] },
    { "ipOutDiscards", "1.3.6.1.2.1.4.11", &_names[58],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[55], &_types[95], NULLOT, &_types[59] },
    { "ipOutNoRoutes", "1.3.6.1.2.1.4.12", &_names[59],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[10], &_types[60], NULLOT, &_types[60] },
    { "ipReasmTimeout", "1.3.6.1.2.1.4.13", &_names[60],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[59], &_types[53], NULLOT, &_types[61] },
    { "ipReasmReqds", "1.3.6.1.2.1.4.14", &_names[61],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[57], &_types[59], NULLOT, &_types[62] },
    { "ipReasmOKs", "1.3.6.1.2.1.4.15", &_names[62],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[64], NULLOT, &_types[63] },
    { "ipReasmFails", "1.3.6.1.2.1.4.16", &_names[63],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[65], NULLOT, &_types[64] },
    { "ipFragOKs", "1.3.6.1.2.1.4.17", &_names[64],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[62], &_types[55], NULLOT, &_types[65] },
    { "ipFragFails", "1.3.6.1.2.1.4.18", &_names[65],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[63], NULLOT, NULLOT, &_types[66] },
    { "ipFragCreates", "1.3.6.1.2.1.4.19", &_names[66],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[67], NULLOT, &_types[67] },
    { "ipAddrTable", "1.3.6.1.2.1.4.20", &_names[67],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[42], &_types[74], &_types[68], &_types[68] },
    { "ipAddrEntry", "1.3.6.1.2.1.4.20.1", &_names[68],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[56], NULLOT, &_types[73], &_types[69] },
    { "ipAdEntAddr", "1.3.6.1.2.1.4.20.1.1", &_names[69],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[46], &_types[72], NULLOT, &_types[70] },
    { "ipAdEntIfIndex", "1.3.6.1.2.1.4.20.1.2", &_names[70],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[44], &_types[71], NULLOT, &_types[71] },
    { "ipAdEntNetMask", "1.3.6.1.2.1.4.20.1.3", &_names[71],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[70], NULLOT, NULLOT, &_types[72] },
    { "ipAdEntBcastAddr", "1.3.6.1.2.1.4.20.1.4", &_names[72],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[69], &_types[70], NULLOT, &_types[73] },
    { "ipAdEntReasmMaxSize", "1.3.6.1.2.1.4.20.1.5", &_names[73],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[9], &_types[69], NULLOT, &_types[74] },
    { "ipRouteTable", "1.3.6.1.2.1.4.21", &_names[74],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[67], &_types[89], &_types[75], &_types[75] },
    { "ipRouteEntry", "1.3.6.1.2.1.4.21.1", &_names[75],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[68], NULLOT, &_types[83], &_types[76] },
    { "ipRouteDest", "1.3.6.1.2.1.4.21.1.1", &_names[76],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[20], &_types[84], NULLOT, &_types[77] },
    { "ipRouteIfIndex", "1.3.6.1.2.1.4.21.1.2", &_names[77],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[71], &_types[85], NULLOT, &_types[78] },
    { "ipRouteMetric1", "1.3.6.1.2.1.4.21.1.3", &_names[78],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[27], &_types[79], NULLOT, &_types[79] },
    { "ipRouteMetric2", "1.3.6.1.2.1.4.21.1.4", &_names[79],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[78], &_types[80], NULLOT, &_types[80] },
    { "ipRouteMetric3", "1.3.6.1.2.1.4.21.1.5", &_names[80],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[79], &_types[81], NULLOT, &_types[81] },
    { "ipRouteMetric4", "1.3.6.1.2.1.4.21.1.6", &_names[81],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[80], &_types[87], NULLOT, &_types[82] },
    { "ipRouteNextHop", "1.3.6.1.2.1.4.21.1.7", &_names[82],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[48], &_types[88], NULLOT, &_types[83] },
    { "ipRouteType", "1.3.6.1.2.1.4.21.1.8", &_names[83],
      (OS) 18, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[75], &_types[82], NULLOT, &_types[84] },
    { "ipRouteProto", "1.3.6.1.2.1.4.21.1.9", &_names[84],
      (OS) 19, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[54], NULLOT, NULLOT, &_types[85] },
    { "ipRouteAge", "1.3.6.1.2.1.4.21.1.10", &_names[85],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[77], &_types[86], NULLOT, &_types[86] },
    { "ipRouteMask", "1.3.6.1.2.1.4.21.1.11", &_names[86],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[85], &_types[78], NULLOT, &_types[87] },
    { "ipRouteMetric5", "1.3.6.1.2.1.4.21.1.12", &_names[87],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[81], &_types[76], NULLOT, &_types[88] },
    { "ipRouteInfo", "1.3.6.1.2.1.4.21.1.13", &_names[88],
      (OS) 6, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[72], &_types[77], NULLOT, &_types[89] },
    { "ipNetToMediaTable", "1.3.6.1.2.1.4.22", &_names[89],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[74], &_types[50], &_types[90], &_types[90] },
    { "ipNetToMediaEntry", "1.3.6.1.2.1.4.22.1", &_names[90],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[83], NULLOT, &_types[94], &_types[91] },
    { "ipNetToMediaIfIndex", "1.3.6.1.2.1.4.22.1.1", &_names[91],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[86], NULLOT, NULLOT, &_types[92] },
    { "ipNetToMediaPhysAddress", "1.3.6.1.2.1.4.22.1.2", &_names[92],
      (OS) 5, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[88], &_types[93], NULLOT, &_types[93] },
    { "ipNetToMediaNetAddress", "1.3.6.1.2.1.4.22.1.3", &_names[93],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[92], &_types[91], NULLOT, &_types[94] },
    { "ipNetToMediaType", "1.3.6.1.2.1.4.22.1.4", &_names[94],
      (OS) 20, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[90], &_types[92], NULLOT, &_types[95] },
    { "ipRoutingDiscards", "1.3.6.1.2.1.4.23", &_names[95],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[58], &_types[54], NULLOT, &_types[96] },
    { "ipForward", "1.3.6.1.2.1.4.24", &_names[96],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[82], &_types[51], &_types[97], &_types[97] },
    { "ipForwardNumber", "1.3.6.1.2.1.4.24.1", &_names[97],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[151], &_types[98], NULLOT, &_types[98] },
    { "ipForwardTable", "1.3.6.1.2.1.4.24.2", &_names[98],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[178], NULLOT, &_types[99], &_types[99] },
    { "ipForwardEntry", "1.3.6.1.2.1.4.24.2.1", &_names[99],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[179], NULLOT, &_types[105], &_types[100] },
    { "ipForwardDest", "1.3.6.1.2.1.4.24.2.1.1", &_names[100],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[76], &_types[106], NULLOT, &_types[101] },
    { "ipForwardMask", "1.3.6.1.2.1.4.24.2.1.2", &_names[101],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[140], &_types[104], NULLOT, &_types[102] },
    { "ipForwardPolicy", "1.3.6.1.2.1.4.24.2.1.3", &_names[102],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[207], &_types[109], NULLOT, &_types[103] },
    { "ipForwardNextHop", "1.3.6.1.2.1.4.24.2.1.4", &_names[103],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[96], &_types[108], NULLOT, &_types[104] },
    { "ipForwardIfIndex", "1.3.6.1.2.1.4.24.2.1.5", &_names[104],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[101], &_types[107], NULLOT, &_types[105] },
    { "ipForwardType", "1.3.6.1.2.1.4.24.2.1.6", &_names[105],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[99], &_types[103], NULLOT, &_types[106] },
    { "ipForwardProto", "1.3.6.1.2.1.4.24.2.1.7", &_names[106],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[133], NULLOT, NULLOT, &_types[107] },
    { "ipForwardAge", "1.3.6.1.2.1.4.24.2.1.8", &_names[107],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[104], &_types[110], NULLOT, &_types[108] },
    { "ipForwardInfo", "1.3.6.1.2.1.4.24.2.1.9", &_names[108],
      (OS) 6, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[221], &_types[101], NULLOT, &_types[109] },
    { "ipForwardNextHopAS", "1.3.6.1.2.1.4.24.2.1.10", &_names[109],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[163], &_types[100], NULLOT, &_types[110] },
    { "ipForwardMetric1", "1.3.6.1.2.1.4.24.2.1.11", &_names[110],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[143], &_types[111], NULLOT, &_types[111] },
    { "ipForwardMetric2", "1.3.6.1.2.1.4.24.2.1.12", &_names[111],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[110], &_types[112], NULLOT, &_types[112] },
    { "ipForwardMetric3", "1.3.6.1.2.1.4.24.2.1.13", &_names[112],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[111], &_types[113], NULLOT, &_types[113] },
    { "ipForwardMetric4", "1.3.6.1.2.1.4.24.2.1.14", &_names[113],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[112], &_types[114], NULLOT, &_types[114] },
    { "ipForwardMetric5", "1.3.6.1.2.1.4.24.2.1.15", &_names[114],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[113], &_types[102], NULLOT, &_types[115] },
    { "icmp", "1.3.6.1.2.1.5", &_names[115],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[5], &_types[197], &_types[122], &_types[116] },
    { "icmpInMsgs", "1.3.6.1.2.1.5.1", &_names[116],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[93], &_types[121], NULLOT, &_types[117] },
    { "icmpInErrors", "1.3.6.1.2.1.5.2", &_names[117],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[52], &_types[130], NULLOT, &_types[118] },
    { "icmpInDestUnreachs", "1.3.6.1.2.1.5.3", &_names[118],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[36], &_types[131], NULLOT, &_types[119] },
    { "icmpInTimeExcds", "1.3.6.1.2.1.5.4", &_names[119],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[50], &_types[132], NULLOT, &_types[120] },
    { "icmpInParmProbs", "1.3.6.1.2.1.5.5", &_names[120],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[84], &_types[133], NULLOT, &_types[121] },
    { "icmpInSrcQuenchs", "1.3.6.1.2.1.5.6", &_names[121],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[116], &_types[129], NULLOT, &_types[122] },
    { "icmpInRedirects", "1.3.6.1.2.1.5.7", &_names[122],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[135], NULLOT, &_types[123] },
    { "icmpInEchos", "1.3.6.1.2.1.5.8", &_names[123],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[136], NULLOT, &_types[124] },
    { "icmpInEchoReps", "1.3.6.1.2.1.5.9", &_names[124],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[390], &_types[126], NULLOT, &_types[125] },
    { "icmpInTimestamps", "1.3.6.1.2.1.5.10", &_names[125],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[60], &_types[138], NULLOT, &_types[126] },
    { "icmpInTimestampReps", "1.3.6.1.2.1.5.11", &_names[126],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[124], &_types[128], NULLOT, &_types[127] },
    { "icmpInAddrMasks", "1.3.6.1.2.1.5.12", &_names[127],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[91], &_types[140], NULLOT, &_types[128] },
    { "icmpInAddrMaskReps", "1.3.6.1.2.1.5.13", &_names[128],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[126], &_types[137], NULLOT, &_types[129] },
    { "icmpOutMsgs", "1.3.6.1.2.1.5.14", &_names[129],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[121], &_types[134], NULLOT, &_types[130] },
    { "icmpOutErrors", "1.3.6.1.2.1.5.15", &_names[130],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[117], &_types[116], NULLOT, &_types[131] },
    { "icmpOutDestUnreachs", "1.3.6.1.2.1.5.16", &_names[131],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[118], &_types[125], NULLOT, &_types[132] },
    { "icmpOutTimeExcds", "1.3.6.1.2.1.5.17", &_names[132],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[119], &_types[123], NULLOT, &_types[133] },
    { "icmpOutParmProbs", "1.3.6.1.2.1.5.18", &_names[133],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[120], &_types[117], NULLOT, &_types[134] },
    { "icmpOutSrcQuenchs", "1.3.6.1.2.1.5.19", &_names[134],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[129], &_types[127], NULLOT, &_types[135] },
    { "icmpOutRedirects", "1.3.6.1.2.1.5.20", &_names[135],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[122], &_types[119], NULLOT, &_types[136] },
    { "icmpOutEchos", "1.3.6.1.2.1.5.21", &_names[136],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[123], &_types[120], NULLOT, &_types[137] },
    { "icmpOutEchoReps", "1.3.6.1.2.1.5.22", &_names[137],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[128], &_types[139], NULLOT, &_types[138] },
    { "icmpOutTimestamps", "1.3.6.1.2.1.5.23", &_names[138],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[125], NULLOT, NULLOT, &_types[139] },
    { "icmpOutTimestampReps", "1.3.6.1.2.1.5.24", &_names[139],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[137], &_types[141], NULLOT, &_types[140] },
    { "icmpOutAddrMasks", "1.3.6.1.2.1.5.25", &_names[140],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[127], &_types[124], NULLOT, &_types[141] },
    { "icmpOutAddrMaskReps", "1.3.6.1.2.1.5.26", &_names[141],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[139], &_types[118], NULLOT, &_types[142] },
    { "tcp", "1.3.6.1.2.1.6", &_names[142],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[164], &_types[150], &_types[143] },
    { "tcpRtoAlgorithm", "1.3.6.1.2.1.6.1", &_names[143],
      (OS) 21, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[87], &_types[152], NULLOT, &_types[144] },
    { "tcpRtoMin", "1.3.6.1.2.1.6.2", &_names[144],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[197], &_types[149], NULLOT, &_types[145] },
    { "tcpRtoMax", "1.3.6.1.2.1.6.3", &_names[145],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[73], &_types[147], NULLOT, &_types[146] },
    { "tcpMaxConn", "1.3.6.1.2.1.6.4", &_names[146],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[11], NULLOT, NULLOT, &_types[147] },
    { "tcpActiveOpens", "1.3.6.1.2.1.6.5", &_names[147],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[145], &_types[148], NULLOT, &_types[148] },
    { "tcpPassiveOpens", "1.3.6.1.2.1.6.6", &_names[148],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[147], &_types[146], NULLOT, &_types[149] },
    { "tcpAttemptFails", "1.3.6.1.2.1.6.7", &_names[149],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[65], &_types[163], NULLOT, &_types[150] },
    { "tcpEstabResets", "1.3.6.1.2.1.6.8", &_names[150],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[34], &_types[143], NULLOT, &_types[151] },
    { "tcpCurrEstab", "1.3.6.1.2.1.6.9", &_names[151],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[16], &_types[162], NULLOT, &_types[152] },
    { "tcpInSegs", "1.3.6.1.2.1.6.10", &_names[152],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[89], &_types[153], NULLOT, &_types[153] },
    { "tcpOutSegs", "1.3.6.1.2.1.6.11", &_names[153],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[152], &_types[154], NULLOT, &_types[154] },
    { "tcpRetransSegs", "1.3.6.1.2.1.6.12", &_names[154],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[153], &_types[155], NULLOT, &_types[155] },
    { "tcpConnTable", "1.3.6.1.2.1.6.13", &_names[155],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[154], &_types[144], &_types[156], &_types[156] },
    { "tcpConnEntry", "1.3.6.1.2.1.6.13.1", &_names[156],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[94], NULLOT, &_types[158], &_types[157] },
    { "tcpConnState", "1.3.6.1.2.1.6.13.1.1", &_names[157],
      (OS) 22, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[150], &_types[159], NULLOT, &_types[158] },
    { "tcpConnLocalAddress", "1.3.6.1.2.1.6.13.1.2", &_names[158],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[134], &_types[160], NULLOT, &_types[159] },
    { "tcpConnLocalPort", "1.3.6.1.2.1.6.13.1.3", &_names[159],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[115], &_types[161], NULLOT, &_types[160] },
    { "tcpConnRemAddress", "1.3.6.1.2.1.6.13.1.4", &_names[160],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[158], &_types[157], NULLOT, &_types[161] },
    { "tcpConnRemPort", "1.3.6.1.2.1.6.13.1.5", &_names[161],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[159], NULLOT, NULLOT, &_types[162] },
    { "tcpInErrs", "1.3.6.1.2.1.6.14", &_names[162],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[130], &_types[145], NULLOT, &_types[163] },
    { "tcpOutRsts", "1.3.6.1.2.1.6.15", &_names[163],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[151], NULLOT, &_types[164] },
    { "udp", "1.3.6.1.2.1.7", &_names[164],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[142], &_types[361], &_types[165], &_types[165] },
    { "udpInDatagrams", "1.3.6.1.2.1.7.1", &_names[165],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[53], &_types[168], NULLOT, &_types[166] },
    { "udpNoPorts", "1.3.6.1.2.1.7.2", &_names[166],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[161], &_types[167], NULLOT, &_types[167] },
    { "udpInErrors", "1.3.6.1.2.1.7.3", &_names[167],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[162], NULLOT, NULLOT, &_types[168] },
    { "udpOutDatagrams", "1.3.6.1.2.1.7.4", &_names[168],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[165], &_types[169], NULLOT, &_types[169] },
    { "udpTable", "1.3.6.1.2.1.7.5", &_names[169],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[155], &_types[166], &_types[170], &_types[170] },
    { "udpEntry", "1.3.6.1.2.1.7.5.1", &_names[170],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[156], NULLOT, &_types[171], &_types[171] },
    { "udpLocalAddress", "1.3.6.1.2.1.7.5.1.1", &_names[171],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[160], &_types[172], NULLOT, &_types[172] },
    { "udpLocalPort", "1.3.6.1.2.1.7.5.1.2", &_names[172],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[166], NULLOT, NULLOT, &_types[173] },
    { "egp", "1.3.6.1.2.1.8", &_names[173],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[7], &_types[175], &_types[174] },
    { "egpInMsgs", "1.3.6.1.2.1.8.1", &_names[174],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[171], &_types[176], NULLOT, &_types[175] },
    { "egpInErrors", "1.3.6.1.2.1.8.2", &_names[175],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[167], &_types[177], NULLOT, &_types[176] },
    { "egpOutMsgs", "1.3.6.1.2.1.8.3", &_names[176],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[174], &_types[178], NULLOT, &_types[177] },
    { "egpOutErrors", "1.3.6.1.2.1.8.4", &_names[177],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[175], &_types[174], NULLOT, &_types[178] },
    { "egpNeighTable", "1.3.6.1.2.1.8.5", &_names[178],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[169], &_types[195], &_types[179], &_types[179] },
    { "egpNeighEntry", "1.3.6.1.2.1.8.5.1", &_names[179],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[170], NULLOT, &_types[184], &_types[180] },
    { "egpNeighState", "1.3.6.1.2.1.8.5.1.1", &_names[180],
      (OS) 23, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[157], &_types[189], NULLOT, &_types[181] },
    { "egpNeighAddr", "1.3.6.1.2.1.8.5.1.2", &_names[181],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[176], &_types[183], NULLOT, &_types[182] },
    { "egpNeighAs", "1.3.6.1.2.1.8.5.1.3", &_names[182],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[190], NULLOT, &_types[183] },
    { "egpNeighInMsgs", "1.3.6.1.2.1.8.5.1.4", &_names[183],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[181], &_types[185], NULLOT, &_types[184] },
    { "egpNeighInErrs", "1.3.6.1.2.1.8.5.1.5", &_names[184],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[177], &_types[186], NULLOT, &_types[185] },
    { "egpNeighOutMsgs", "1.3.6.1.2.1.8.5.1.6", &_names[185],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[183], &_types[187], NULLOT, &_types[186] },
    { "egpNeighOutErrs", "1.3.6.1.2.1.8.5.1.7", &_names[186],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[184], &_types[193], NULLOT, &_types[187] },
    { "egpNeighInErrMsgs", "1.3.6.1.2.1.8.5.1.8", &_names[187],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[185], &_types[188], NULLOT, &_types[188] },
    { "egpNeighOutErrMsgs", "1.3.6.1.2.1.8.5.1.9", &_names[188],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[187], &_types[180], NULLOT, &_types[189] },
    { "egpNeighStateUps", "1.3.6.1.2.1.8.5.1.10", &_names[189],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[138], &_types[191], NULLOT, &_types[190] },
    { "egpNeighStateDowns", "1.3.6.1.2.1.8.5.1.11", &_names[190],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[49], NULLOT, NULLOT, &_types[191] },
    { "egpNeighIntervalHello", "1.3.6.1.2.1.8.5.1.12", &_names[191],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[192], NULLOT, &_types[192] },
    { "egpNeighIntervalPoll", "1.3.6.1.2.1.8.5.1.13", &_names[192],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[194], NULLOT, &_types[193] },
    { "egpNeighMode", "1.3.6.1.2.1.8.5.1.14", &_names[193],
      (OS) 24, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[146], &_types[181], NULLOT, &_types[194] },
    { "egpNeighEventTrigger", "1.3.6.1.2.1.8.5.1.15", &_names[194],
      (OS) 25, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[182], NULLOT, &_types[195] },
    { "egpAs", "1.3.6.1.2.1.8.6", &_names[195],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[182], NULLOT, NULLOT, &_types[196] },
    { "transmission", "1.3.6.1.2.1.10", &_names[196],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[47], NULLOT, &_types[197] },
    { "snmp", "1.3.6.1.2.1.11", &_names[197],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, &_types[207], &_types[198] },
    { "snmpInPkts", "1.3.6.1.2.1.11.1", &_names[198],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[131], &_types[199], NULLOT, &_types[199] },
    { "snmpOutPkts", "1.3.6.1.2.1.11.2", &_names[199],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[198], NULLOT, NULLOT, &_types[200] },
    { "snmpInBadVersions", "1.3.6.1.2.1.11.3", &_names[200],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[206], NULLOT, &_types[201] },
    { "snmpInBadCommunityNames", "1.3.6.1.2.1.11.4", &_names[201],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[12], &_types[205], NULLOT, &_types[202] },
    { "snmpInBadCommunityUses", "1.3.6.1.2.1.11.5", &_names[202],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[215], NULLOT, &_types[203] },
    { "snmpInASNParseErrs", "1.3.6.1.2.1.11.6", &_names[203],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[186], &_types[208], NULLOT, &_types[204] },
    { "snmpInTooBigs", "1.3.6.1.2.1.11.8", &_names[204],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[180], &_types[214], NULLOT, &_types[205] },
    { "snmpInNoSuchNames", "1.3.6.1.2.1.11.9", &_names[205],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[201], &_types[217], NULLOT, &_types[206] },
    { "snmpInBadValues", "1.3.6.1.2.1.11.10", &_names[206],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[188], &_types[212], NULLOT, &_types[207] },
    { "snmpInReadOnlys", "1.3.6.1.2.1.11.11", &_names[207],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[192], &_types[202], NULLOT, &_types[208] },
    { "snmpInGenErrs", "1.3.6.1.2.1.11.12", &_names[208],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[203], &_types[219], NULLOT, &_types[209] },
    { "snmpInTotalReqVars", "1.3.6.1.2.1.11.13", &_names[209],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[432], &_types[210], NULLOT, &_types[210] },
    { "snmpInTotalSetVars", "1.3.6.1.2.1.11.14", &_names[210],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[209], &_types[203], NULLOT, &_types[211] },
    { "snmpInGetRequests", "1.3.6.1.2.1.11.15", &_names[211],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[61], &_types[213], NULLOT, &_types[212] },
    { "snmpInGetNexts", "1.3.6.1.2.1.11.16", &_names[212],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[206], &_types[218], NULLOT, &_types[213] },
    { "snmpInSetRequests", "1.3.6.1.2.1.11.17", &_names[213],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[211], &_types[220], NULLOT, &_types[214] },
    { "snmpInGetResponses", "1.3.6.1.2.1.11.18", &_names[214],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[204], &_types[216], NULLOT, &_types[215] },
    { "snmpInTraps", "1.3.6.1.2.1.11.19", &_names[215],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[196], &_types[224], NULLOT, &_types[216] },
    { "snmpOutTooBigs", "1.3.6.1.2.1.11.20", &_names[216],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[214], &_types[223], NULLOT, &_types[217] },
    { "snmpOutNoSuchNames", "1.3.6.1.2.1.11.21", &_names[217],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[205], &_types[198], NULLOT, &_types[218] },
    { "snmpOutBadValues", "1.3.6.1.2.1.11.22", &_names[218],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[212], &_types[221], NULLOT, &_types[219] },
    { "snmpOutGenErrs", "1.3.6.1.2.1.11.24", &_names[219],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[208], &_types[200], NULLOT, &_types[220] },
    { "snmpOutGetRequests", "1.3.6.1.2.1.11.25", &_names[220],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[213], &_types[222], NULLOT, &_types[221] },
    { "snmpOutGetNexts", "1.3.6.1.2.1.11.26", &_names[221],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[218], &_types[204], NULLOT, &_types[222] },
    { "snmpOutSetRequests", "1.3.6.1.2.1.11.27", &_names[222],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[220], &_types[201], NULLOT, &_types[223] },
    { "snmpOutGetResponses", "1.3.6.1.2.1.11.28", &_names[223],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[216], &_types[211], NULLOT, &_types[224] },
    { "snmpOutTraps", "1.3.6.1.2.1.11.29", &_names[224],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[215], &_types[225], NULLOT, &_types[225] },
    { "snmpEnableAuthenTraps", "1.3.6.1.2.1.11.30", &_names[225],
      (OS) 26, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[224], &_types[209], NULLOT, &_types[226] },
    { "ospf", "1.3.6.1.2.1.14", &_names[226],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[190], &_types[333], &_types[227], &_types[227] },
    { "ospfGeneralGroup", "1.3.6.1.2.1.14.1", &_names[227],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[148], &_types[238], &_types[229], &_types[228] },
    { "ospfRouterId", "1.3.6.1.2.1.14.1.1", &_names[228],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[235], NULLOT, &_types[229] },
    { "ospfAdminStat", "1.3.6.1.2.1.14.1.2", &_names[229],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[223], &_types[231], NULLOT, &_types[230] },
    { "ospfVersionNumber", "1.3.6.1.2.1.14.1.3", &_names[230],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[97], NULLOT, NULLOT, &_types[231] },
    { "ospfAreaBdrRtrStatus", "1.3.6.1.2.1.14.1.4", &_names[231],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[229], &_types[232], NULLOT, &_types[232] },
    { "ospfASBdrRtrStatus", "1.3.6.1.2.1.14.1.5", &_names[232],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[231], &_types[236], NULLOT, &_types[233] },
    { "ospfExternLSACount", "1.3.6.1.2.1.14.1.6", &_names[233],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[103], &_types[230], NULLOT, &_types[234] },
    { "ospfExternLSACksumSum", "1.3.6.1.2.1.14.1.7", &_names[234],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[105], &_types[233], NULLOT, &_types[235] },
    { "ospfTOSSupport", "1.3.6.1.2.1.14.1.8", &_names[235],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[95], &_types[234], NULLOT, &_types[236] },
    { "ospfOriginateNewLSAs", "1.3.6.1.2.1.14.1.9", &_names[236],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[195], &_types[237], NULLOT, &_types[237] },
    { "ospfRxNewLSAs", "1.3.6.1.2.1.14.1.10", &_names[237],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[236], &_types[228], NULLOT, &_types[238] },
    { "ospfAreaTable", "1.3.6.1.2.1.14.2", &_names[238],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[98], &_types[248], &_types[239], &_types[239] },
    { "ospfAreaEntry", "1.3.6.1.2.1.14.2.1", &_names[239],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[234], NULLOT, &_types[241], &_types[240] },
    { "ospfAreaId", "1.3.6.1.2.1.14.2.1.1", &_names[240],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[228], NULLOT, NULLOT, &_types[241] },
    { "ospfAuthType", "1.3.6.1.2.1.14.2.1.2", &_names[241],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[239], &_types[243], NULLOT, &_types[242] },
    { "ospfImportASExtern", "1.3.6.1.2.1.14.2.1.3", &_names[242],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[108], &_types[240], NULLOT, &_types[243] },
    { "ospfSpfRuns", "1.3.6.1.2.1.14.2.1.4", &_names[243],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[241], &_types[247], NULLOT, &_types[244] },
    { "ospfAreaBdrRtrCount", "1.3.6.1.2.1.14.2.1.5", &_names[244],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[233], &_types[245], NULLOT, &_types[245] },
    { "ospfASBdrRtrCount", "1.3.6.1.2.1.14.2.1.6", &_names[245],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[244], &_types[246], NULLOT, &_types[246] },
    { "ospfAreaLSACount", "1.3.6.1.2.1.14.2.1.7", &_names[246],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[245], &_types[242], NULLOT, &_types[247] },
    { "ospfAreaLSACksumSum", "1.3.6.1.2.1.14.2.1.8", &_names[247],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[243], &_types[244], NULLOT, &_types[248] },
    { "ospfStubAreaTable", "1.3.6.1.2.1.14.3", &_names[248],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[238], &_types[254], &_types[249], &_types[249] },
    { "ospfStubAreaEntry", "1.3.6.1.2.1.14.3.1", &_names[249],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[247], NULLOT, &_types[250], &_types[250] },
    { "ospfStubAreaID", "1.3.6.1.2.1.14.3.1.1", &_names[250],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[227], &_types[253], NULLOT, &_types[251] },
    { "ospfStubTOS", "1.3.6.1.2.1.14.3.1.2", &_names[251],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[109], NULLOT, NULLOT, &_types[252] },
    { "ospfStubMetric", "1.3.6.1.2.1.14.3.1.3", &_names[252],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[114], &_types[251], NULLOT, &_types[253] },
    { "ospfStubStatus", "1.3.6.1.2.1.14.3.1.4", &_names[253],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[232], &_types[252], NULLOT, &_types[254] },
    { "ospfLsdbTable", "1.3.6.1.2.1.14.4", &_names[254],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[248], &_types[264], &_types[255], &_types[255] },
    { "ospfLsdbEntry", "1.3.6.1.2.1.14.4.1", &_names[255],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[249], NULLOT, &_types[257], &_types[256] },
    { "ospfLsdbAreaId", "1.3.6.1.2.1.14.4.1.1", &_names[256],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[240], &_types[259], NULLOT, &_types[257] },
    { "ospfLsdbType", "1.3.6.1.2.1.14.4.1.2", &_names[257],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[255], &_types[258], NULLOT, &_types[258] },
    { "ospfLsdbLSID", "1.3.6.1.2.1.14.4.1.3", &_names[258],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[250], &_types[262], NULLOT, &_types[259] },
    { "ospfLsdbRouterId", "1.3.6.1.2.1.14.4.1.4", &_names[259],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[256], &_types[263], NULLOT, &_types[260] },
    { "ospfLsdbSequence", "1.3.6.1.2.1.14.4.1.5", &_names[260],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[107], &_types[261], NULLOT, &_types[261] },
    { "ospfLsdbAge", "1.3.6.1.2.1.14.4.1.6", &_names[261],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[260], &_types[256], NULLOT, &_types[262] },
    { "ospfLsdbChecksum", "1.3.6.1.2.1.14.4.1.7", &_names[262],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[253], &_types[260], NULLOT, &_types[263] },
    { "ospfLsdbAdvertisement", "1.3.6.1.2.1.14.4.1.8", &_names[263],
      (OS) 3, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[251], NULLOT, NULLOT, &_types[264] },
    { "ospfAreaRangeTable", "1.3.6.1.2.1.14.5", &_names[264],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[254], &_types[270], &_types[265], &_types[265] },
    { "ospfAreaRangeEntry", "1.3.6.1.2.1.14.5.1", &_names[265],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[257], NULLOT, &_types[266], &_types[266] },
    { "ospfAreaRangeAreaID", "1.3.6.1.2.1.14.5.1.1", &_names[266],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[258], &_types[269], NULLOT, &_types[267] },
    { "ospfAreaRangeNet", "1.3.6.1.2.1.14.5.1.2", &_names[267],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[141], NULLOT, NULLOT, &_types[268] },
    { "ospfAreaRangeMask", "1.3.6.1.2.1.14.5.1.3", &_names[268],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[261], &_types[267], NULLOT, &_types[269] },
    { "ospfAreaRangeStatus", "1.3.6.1.2.1.14.5.1.4", &_names[269],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[262], &_types[268], NULLOT, &_types[270] },
    { "ospfHostTable", "1.3.6.1.2.1.14.6", &_names[270],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[264], &_types[276], &_types[271], &_types[271] },
    { "ospfHostEntry", "1.3.6.1.2.1.14.6.1", &_names[271],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[265], NULLOT, &_types[272], &_types[272] },
    { "ospfHostIpAddress", "1.3.6.1.2.1.14.6.1.1", &_names[272],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[242], &_types[275], NULLOT, &_types[273] },
    { "ospfHostTOS", "1.3.6.1.2.1.14.6.1.2", &_names[273],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[263], NULLOT, NULLOT, &_types[274] },
    { "ospfHostMetric", "1.3.6.1.2.1.14.6.1.3", &_names[274],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[252], &_types[273], NULLOT, &_types[275] },
    { "ospfHostStatus", "1.3.6.1.2.1.14.6.1.4", &_names[275],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[269], &_types[274], NULLOT, &_types[276] },
    { "ospfIfTable", "1.3.6.1.2.1.14.7", &_names[276],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[270], &_types[294], &_types[277], &_types[277] },
    { "ospfIfEntry", "1.3.6.1.2.1.14.7.1", &_names[277],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[271], NULLOT, &_types[281], &_types[278] },
    { "ospfIfIpAddress", "1.3.6.1.2.1.14.7.1.1", &_names[278],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[272], &_types[282], NULLOT, &_types[279] },
    { "ospfAddressLessIf", "1.3.6.1.2.1.14.7.1.2", &_names[279],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[285], NULLOT, &_types[280] },
    { "ospfIfAreaId", "1.3.6.1.2.1.14.7.1.3", &_names[280],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[259], &_types[279], NULLOT, &_types[281] },
    { "ospfIfType", "1.3.6.1.2.1.14.7.1.4", &_names[281],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[277], &_types[284], NULLOT, &_types[282] },
    { "ospfIfAdminStat", "1.3.6.1.2.1.14.7.1.5", &_names[282],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[275], &_types[289], NULLOT, &_types[283] },
    { "ospfIfRtrPriority", "1.3.6.1.2.1.14.7.1.6", &_names[283],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[210], &_types[278], NULLOT, &_types[284] },
    { "ospfIfTransitDelay", "1.3.6.1.2.1.14.7.1.7", &_names[284],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[281], &_types[283], NULLOT, &_types[285] },
    { "ospfIfRetransInterval", "1.3.6.1.2.1.14.7.1.8", &_names[285],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[15], &_types[286], NULLOT, &_types[286] },
    { "ospfIfHelloInterval", "1.3.6.1.2.1.14.7.1.9", &_names[286],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[285], &_types[287], NULLOT, &_types[287] },
    { "ospfIfRtrDeadInterval", "1.3.6.1.2.1.14.7.1.10", &_names[287],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[286], &_types[288], NULLOT, &_types[288] },
    { "ospfIfPollInterval", "1.3.6.1.2.1.14.7.1.11", &_names[288],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[287], NULLOT, NULLOT, &_types[289] },
    { "ospfIfState", "1.3.6.1.2.1.14.7.1.12", &_names[289],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[282], &_types[293], NULLOT, &_types[290] },
    { "ospfIfDesignatedRouter", "1.3.6.1.2.1.14.7.1.13", &_names[290],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[189], &_types[291], NULLOT, &_types[291] },
    { "ospfIfBackupDesignatedRouter", "1.3.6.1.2.1.14.7.1.14", &_names[291],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[290], &_types[292], NULLOT, &_types[292] },
    { "ospfIfEvents", "1.3.6.1.2.1.14.7.1.15", &_names[292],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[280], NULLOT, &_types[293] },
    { "ospfIfAuthKey", "1.3.6.1.2.1.14.7.1.16", &_names[293],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[268], &_types[290], NULLOT, &_types[294] },
    { "ospfIfMetricTable", "1.3.6.1.2.1.14.8", &_names[294],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[276], &_types[301], &_types[295], &_types[295] },
    { "ospfIfMetricEntry", "1.3.6.1.2.1.14.8.1", &_names[295],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[284], NULLOT, &_types[296], &_types[296] },
    { "ospfIfMetricIpAddress", "1.3.6.1.2.1.14.8.1.1", &_names[296],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[278], &_types[300], NULLOT, &_types[297] },
    { "ospfIfMetricAddressLessIf", "1.3.6.1.2.1.14.8.1.2", &_names[297],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[279], &_types[298], NULLOT, &_types[298] },
    { "ospfIfMetricTOS", "1.3.6.1.2.1.14.8.1.3", &_names[298],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[273], NULLOT, NULLOT, &_types[299] },
    { "ospfIfMetricMetric", "1.3.6.1.2.1.14.8.1.4", &_names[299],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[274], &_types[297], NULLOT, &_types[300] },
    { "ospfIfMetricStatus", "1.3.6.1.2.1.14.8.1.5", &_names[300],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[289], &_types[299], NULLOT, &_types[301] },
    { "ospfVirtIfTable", "1.3.6.1.2.1.14.9", &_names[301],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[294], &_types[313], &_types[302], &_types[302] },
    { "ospfVirtIfEntry", "1.3.6.1.2.1.14.9.1", &_names[302],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[295], NULLOT, &_types[305], &_types[303] },
    { "ospfVirtIfAreaID", "1.3.6.1.2.1.14.9.1.1", &_names[303],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[266], &_types[309], NULLOT, &_types[304] },
    { "ospfVirtIfNeighbor", "1.3.6.1.2.1.14.9.1.2", &_names[304],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[144], &_types[306], NULLOT, &_types[305] },
    { "ospfVirtIfTransitDelay", "1.3.6.1.2.1.14.9.1.3", &_names[305],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[302], &_types[303], NULLOT, &_types[306] },
    { "ospfVirtIfRetransInterval", "1.3.6.1.2.1.14.9.1.4", &_names[306],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[288], &_types[307], NULLOT, &_types[307] },
    { "ospfVirtIfHelloInterval", "1.3.6.1.2.1.14.9.1.5", &_names[307],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[306], &_types[308], NULLOT, &_types[308] },
    { "ospfVirtIfRtrDeadInterval", "1.3.6.1.2.1.14.9.1.6", &_names[308],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[307], NULLOT, NULLOT, &_types[309] },
    { "ospfVirtIfState", "1.3.6.1.2.1.14.9.1.7", &_names[309],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[300], &_types[312], NULLOT, &_types[310] },
    { "ospfVirtIfEvents", "1.3.6.1.2.1.14.9.1.8", &_names[310],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[292], &_types[304], NULLOT, &_types[311] },
    { "ospfVirtIfAuthKey", "1.3.6.1.2.1.14.9.1.9", &_names[311],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[293], &_types[310], NULLOT, &_types[312] },
    { "ospfVirtIfStatus", "1.3.6.1.2.1.14.9.1.10", &_names[312],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[309], &_types[311], NULLOT, &_types[313] },
    { "ospfNbrTable", "1.3.6.1.2.1.14.10", &_names[313],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[301], &_types[324], &_types[314], &_types[314] },
    { "ospfNbrEntry", "1.3.6.1.2.1.14.10.1", &_names[314],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[305], NULLOT, &_types[319], &_types[315] },
    { "ospfNbrIpAddr", "1.3.6.1.2.1.14.10.1.1", &_names[315],
      (OS) 8, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[296], &_types[320], NULLOT, &_types[316] },
    { "ospfNbrAddressLessIndex", "1.3.6.1.2.1.14.10.1.2", &_names[316],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[311], &_types[322], NULLOT, &_types[317] },
    { "ospfNbrRtrId", "1.3.6.1.2.1.14.10.1.3", &_names[317],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[280], &_types[318], NULLOT, &_types[318] },
    { "ospfNbrOptions", "1.3.6.1.2.1.14.10.1.4", &_names[318],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[298], NULLOT, NULLOT, &_types[319] },
    { "ospfNbrPriority", "1.3.6.1.2.1.14.10.1.5", &_names[319],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[283], &_types[315], NULLOT, &_types[320] },
    { "ospfNbrState", "1.3.6.1.2.1.14.10.1.6", &_names[320],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[312], &_types[323], NULLOT, &_types[321] },
    { "ospfNbrEvents", "1.3.6.1.2.1.14.10.1.7", &_names[321],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[310], &_types[317], NULLOT, &_types[322] },
    { "ospfNbrLSRetransQLen", "1.3.6.1.2.1.14.10.1.8", &_names[322],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[313], &_types[321], NULLOT, &_types[323] },
    { "ospfNBMANbrStatus", "1.3.6.1.2.1.14.10.1.9", &_names[323],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[320], &_types[316], NULLOT, &_types[324] },
    { "ospfVirtNbrTable", "1.3.6.1.2.1.14.11", &_names[324],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[322], NULLOT, &_types[325], &_types[325] },
    { "ospfVirtNbrEntry", "1.3.6.1.2.1.14.11.1", &_names[325],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[314], NULLOT, &_types[328], &_types[326] },
    { "ospfVirtNbrArea", "1.3.6.1.2.1.14.11.1.1", &_names[326],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[321], &_types[331], NULLOT, &_types[327] },
    { "ospfVirtNbrRtrId", "1.3.6.1.2.1.14.11.1.2", &_names[327],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[317], &_types[329], NULLOT, &_types[328] },
    { "ospfVirtNbrIpAddr", "1.3.6.1.2.1.14.11.1.3", &_names[328],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[315], &_types[330], NULLOT, &_types[329] },
    { "ospfVirtNbrOptions", "1.3.6.1.2.1.14.11.1.4", &_names[329],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[318], NULLOT, NULLOT, &_types[330] },
    { "ospfVirtNbrState", "1.3.6.1.2.1.14.11.1.5", &_names[330],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[323], &_types[332], NULLOT, &_types[331] },
    { "ospfVirtNbrEvents", "1.3.6.1.2.1.14.11.1.6", &_names[331],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[326], &_types[327], NULLOT, &_types[332] },
    { "ospfVirtNbrLSRetransQLen", "1.3.6.1.2.1.14.11.1.7", &_names[332],
      (OS) 11, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[324], &_types[326], NULLOT, &_types[333] },
    { "bgp", "1.3.6.1.2.1.15", &_names[333],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[325], &_types[142], &_types[334], &_types[334] },
    { "bgpVersion", "1.3.6.1.2.1.15.1", &_names[334],
      (OS) 3, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[200], &_types[336], NULLOT, &_types[335] },
    { "bgpLocalAs", "1.3.6.1.2.1.15.2", &_names[335],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[237], NULLOT, NULLOT, &_types[336] },
    { "bgpPeerTable", "1.3.6.1.2.1.15.3", &_names[336],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[332], &_types[353], &_types[337], &_types[337] },
    { "bgpPeerEntry", "1.3.6.1.2.1.15.3.1", &_names[337],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[333], NULLOT, &_types[351], &_types[338] },
    { "bgpPeerIdentifier", "1.3.6.1.2.1.15.3.1.1", &_names[338],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[352], &_types[347], NULLOT, &_types[339] },
    { "bgpPeerState", "1.3.6.1.2.1.15.3.1.2", &_names[339],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[330], &_types[340], NULLOT, &_types[340] },
    { "bgpPeerAdminStatus", "1.3.6.1.2.1.15.3.1.3", &_names[340],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[339], &_types[349], NULLOT, &_types[341] },
    { "bgpPeerNegotiatedVersion", "1.3.6.1.2.1.15.3.1.4", &_names[341],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[334], &_types[342], NULLOT, &_types[342] },
    { "bgpPeerLocalAddr", "1.3.6.1.2.1.15.3.1.5", &_names[342],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[328], &_types[344], NULLOT, &_types[343] },
    { "bgpPeerLocalPort", "1.3.6.1.2.1.15.3.1.6", &_names[343],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[172], &_types[345], NULLOT, &_types[344] },
    { "bgpPeerRemoteAddr", "1.3.6.1.2.1.15.3.1.7", &_names[344],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[342], &_types[339], NULLOT, &_types[345] },
    { "bgpPeerRemotePort", "1.3.6.1.2.1.15.3.1.8", &_names[345],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[343], &_types[338], NULLOT, &_types[346] },
    { "bgpPeerRemoteAs", "1.3.6.1.2.1.15.3.1.9", &_names[346],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[335], NULLOT, NULLOT, &_types[347] },
    { "bgpPeerInUpdates", "1.3.6.1.2.1.15.3.1.10", &_names[347],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[0], &_types[348], NULLOT, &_types[348] },
    { "bgpPeerOutUpdates", "1.3.6.1.2.1.15.3.1.11", &_names[348],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[347], &_types[346], NULLOT, &_types[349] },
    { "bgpPeerInTotalMessages", "1.3.6.1.2.1.15.3.1.12", &_names[349],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[350], NULLOT, &_types[350] },
    { "bgpPeerOutTotalMessages", "1.3.6.1.2.1.15.3.1.13", &_names[350],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[349], &_types[343], NULLOT, &_types[351] },
    { "bgpPeerLastError", "1.3.6.1.2.1.15.3.1.14", &_names[351],
      (OS) 3, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[219], &_types[341], NULLOT, &_types[352] },
    { "bgpIdentifier", "1.3.6.1.2.1.15.4", &_names[352],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[136], &_types[335], NULLOT, &_types[353] },
    { "bgpRcvdPathAttrTable", "1.3.6.1.2.1.15.5", &_names[353],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[336], &_types[352], &_types[354], &_types[354] },
    { "bgpPathAttrEntry", "1.3.6.1.2.1.15.5.1", &_names[354],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[337], NULLOT, &_types[359], &_types[355] },
    { "bgpPathAttrPeer", "1.3.6.1.2.1.15.5.1.1", &_names[355],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[132], NULLOT, NULLOT, &_types[356] },
    { "bgpPathAttrDestNetwork", "1.3.6.1.2.1.15.5.1.2", &_names[356],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[267], &_types[360], NULLOT, &_types[357] },
    { "bgpPathAttrOrigin", "1.3.6.1.2.1.15.5.1.3", &_names[357],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[230], &_types[358], NULLOT, &_types[358] },
    { "bgpPathAttrASPath", "1.3.6.1.2.1.15.5.1.4", &_names[358],
      (OS) 3, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[341], &_types[356], NULLOT, &_types[359] },
    { "bgpPathAttrNextHop", "1.3.6.1.2.1.15.5.1.5", &_names[359],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[246], &_types[357], NULLOT, &_types[360] },
    { "bgpPathAttrInterASMetric", "1.3.6.1.2.1.15.5.1.6", &_names[360],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[299], &_types[355], NULLOT, &_types[361] },
    { "rip2", "1.3.6.1.2.1.23", &_names[361],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[199], &_types[115], &_types[365], &_types[362] },
    { "rip2GlobalGroup", "1.3.6.1.2.1.23.1", &_names[362],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[303], NULLOT, &_types[364], &_types[363] },
    { "rip2GlobalRouteChanges", "1.3.6.1.2.1.23.1.1", &_names[363],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[360], NULLOT, NULLOT, &_types[364] },
    { "rip2GlobalQueries", "1.3.6.1.2.1.23.1.2", &_names[364],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[344], &_types[363], NULLOT, &_types[365] },
    { "rip2IfStatTable", "1.3.6.1.2.1.23.2", &_names[365],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[353], &_types[372], &_types[366], &_types[366] },
    { "rip2IfStatEntry", "1.3.6.1.2.1.23.2.1", &_names[366],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[354], NULLOT, &_types[367], &_types[367] },
    { "rip2IfStatAddress", "1.3.6.1.2.1.23.2.1.1", &_names[367],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[364], &_types[371], NULLOT, &_types[368] },
    { "rip2IfStatRcvBadPackets", "1.3.6.1.2.1.23.2.1.2", &_names[368],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[304], &_types[370], NULLOT, &_types[369] },
    { "rip2IfStatRcvBadRoutes", "1.3.6.1.2.1.23.2.1.3", &_names[369],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[291], &_types[368], NULLOT, &_types[370] },
    { "rip2IfStatSentUpdates", "1.3.6.1.2.1.23.2.1.4", &_names[370],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[348], NULLOT, NULLOT, &_types[371] },
    { "rip2IfStatStatus", "1.3.6.1.2.1.23.2.1.5", &_names[371],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[340], &_types[369], NULLOT, &_types[372] },
    { "rip2IfConfTable", "1.3.6.1.2.1.23.3", &_names[372],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[365], &_types[382], &_types[373], &_types[373] },
    { "rip2IfConfEntry", "1.3.6.1.2.1.23.3.1", &_names[373],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[366], NULLOT, &_types[376], &_types[374] },
    { "rip2IfConfAddress", "1.3.6.1.2.1.23.3.1.1", &_names[374],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[367], &_types[381], NULLOT, &_types[375] },
    { "rip2IfConfDomain", "1.3.6.1.2.1.23.3.1.2", &_names[375],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[193], &_types[374], NULLOT, &_types[376] },
    { "rip2IfConfAuthType", "1.3.6.1.2.1.23.3.1.3", &_names[376],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[373], &_types[375], NULLOT, &_types[377] },
    { "rip2IfConfAuthKey", "1.3.6.1.2.1.23.3.1.4", &_names[377],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[316], &_types[378], NULLOT, &_types[378] },
    { "rip2IfConfSend", "1.3.6.1.2.1.23.3.1.5", &_names[378],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[363], &_types[380], NULLOT, &_types[379] },
    { "rip2IfConfReceive", "1.3.6.1.2.1.23.3.1.6", &_names[379],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[355], NULLOT, NULLOT, &_types[380] },
    { "rip2IfConfDefaultMetric", "1.3.6.1.2.1.23.3.1.7", &_names[380],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[378], &_types[379], NULLOT, &_types[381] },
    { "rip2IfConfStatus", "1.3.6.1.2.1.23.3.1.8", &_names[381],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[371], &_types[377], NULLOT, &_types[382] },
    { "rip2PeerTable", "1.3.6.1.2.1.23.4", &_names[382],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[372], &_types[362], &_types[383], &_types[383] },
    { "rip2PeerEntry", "1.3.6.1.2.1.23.4.1", &_names[383],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[376], NULLOT, &_types[387], &_types[384] },
    { "rip2PeerAddress", "1.3.6.1.2.1.23.4.1.1", &_names[384],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[374], &_types[389], NULLOT, &_types[385] },
    { "rip2PeerDomain", "1.3.6.1.2.1.23.4.1.2", &_names[385],
      (OS) 3, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[375], &_types[384], NULLOT, &_types[386] },
    { "rip2PeerLastUpdate", "1.3.6.1.2.1.23.4.1.3", &_names[386],
      (OS) 12, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[370], NULLOT, NULLOT, &_types[387] },
    { "rip2PeerVersion", "1.3.6.1.2.1.23.4.1.4", &_names[387],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[358], &_types[385], NULLOT, &_types[388] },
    { "rip2PeerRcvBadPackets", "1.3.6.1.2.1.23.4.1.5", &_names[388],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[368], &_types[386], NULLOT, &_types[389] },
    { "rip2PeerRcvBadRoutes", "1.3.6.1.2.1.23.4.1.6", &_names[389],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[369], &_types[388], NULLOT, &_types[390] },
    { "experimental", "1.3.6.1.3", &_names[390],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[5], &_types[391], &_types[391] },
    { "view", "1.3.6.1.3.11", &_names[391],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[388], NULLOT, &_types[400], &_types[392] },
    { "viewPrimTable", "1.3.6.1.3.11.1", &_names[392],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[382], &_types[412], &_types[393], &_types[393] },
    { "viewPrimEntry", "1.3.6.1.3.11.1.1", &_names[393],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[383], NULLOT, &_types[399], &_types[394] },
    { "viewPrimName", "1.3.6.1.3.11.1.1.1", &_names[394],
      (OS) 6, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[217], &_types[397], NULLOT, &_types[395] },
    { "viewPrimTDomain", "1.3.6.1.3.11.1.1.2", &_names[395],
      (OS) 6, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[411], &_types[396], NULLOT, &_types[396] },
    { "viewPrimTAddr", "1.3.6.1.3.11.1.1.3", &_names[396],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[384], &_types[398], NULLOT, &_types[397] },
    { "viewPrimUser", "1.3.6.1.3.11.1.1.4", &_names[397],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[202], NULLOT, NULLOT, &_types[398] },
    { "viewPrimCommunity", "1.3.6.1.3.11.1.1.5", &_names[398],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[396], &_types[394], NULLOT, &_types[399] },
    { "viewPrimType", "1.3.6.1.3.11.1.1.6", &_names[399],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[393], &_types[395], NULLOT, &_types[400] },
    { "defaultView", "1.3.6.1.3.11.2", &_names[400],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[391], &_types[406], &_types[401], &_types[401] },
    { "defViewWholeRW", "1.3.6.1.3.11.2.1", &_names[401],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[403], NULLOT, &_types[402] },
    { "defViewWholeRO", "1.3.6.1.3.11.2.2", &_names[402],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[308], &_types[404], NULLOT, &_types[403] },
    { "defViewStandardRW", "1.3.6.1.3.11.2.3", &_names[403],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[401], &_types[405], NULLOT, &_types[404] },
    { "defViewStandardRO", "1.3.6.1.3.11.2.4", &_names[404],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[402], NULLOT, NULLOT, &_types[405] },
    { "defViewTrapDest", "1.3.6.1.3.11.2.5", &_names[405],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[100], &_types[402], NULLOT, &_types[406] },
    { "viewDomains", "1.3.6.1.3.11.3", &_names[406],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[385], &_types[392], &_types[407], &_types[407] },
    { "snmpDomain", "1.3.6.1.3.11.3.1", &_names[407],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[406], NULLOT, &_types[408], &_types[408] },
    { "rfc1157Domain", "1.3.6.1.3.11.3.1.1", &_names[408],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[407], &_types[409], NULLOT, &_types[409] },
    { "cltsDomain", "1.3.6.1.3.11.3.1.3", &_names[409],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[408], &_types[410], NULLOT, &_types[410] },
    { "cotsNDomain", "1.3.6.1.3.11.3.1.4", &_names[410],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[409], &_types[411], NULLOT, &_types[411] },
    { "cotsXDomain", "1.3.6.1.3.11.3.1.5", &_names[411],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[410], NULLOT, NULLOT, &_types[412] },
    { "viewAclTable", "1.3.6.1.3.11.4", &_names[412],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[392], &_types[419], &_types[413], &_types[413] },
    { "viewAclEntry", "1.3.6.1.3.11.4.1", &_names[413],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[399], NULLOT, &_types[418], &_types[414] },
    { "viewAclView", "1.3.6.1.3.11.4.1.1", &_names[414],
      (OS) 6, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[400], &_types[416], NULLOT, &_types[415] },
    { "viewAclCommunity", "1.3.6.1.3.11.4.1.2", &_names[415],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[398], &_types[414], NULLOT, &_types[416] },
    { "viewAclUser", "1.3.6.1.3.11.4.1.3", &_names[416],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[397], NULLOT, NULLOT, &_types[417] },
    { "viewAclPrivileges", "1.3.6.1.3.11.4.1.4", &_names[417],
      (OS) 2, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[319], &_types[415], NULLOT, &_types[418] },
    { "viewAclType", "1.3.6.1.3.11.4.1.5", &_names[418],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[413], &_types[417], NULLOT, &_types[419] },
    { "viewTrapTable", "1.3.6.1.3.11.5", &_names[419],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[412], &_types[425], &_types[420], &_types[420] },
    { "viewTrapEntry", "1.3.6.1.3.11.5.1", &_names[420],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[418], NULLOT, &_types[424], &_types[421] },
    { "viewTrapView", "1.3.6.1.3.11.5.1.1", &_names[421],
      (OS) 6, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[414], &_types[422], NULLOT, &_types[422] },
    { "viewTrapGenerics", "1.3.6.1.3.11.5.1.2", &_names[422],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[379], &_types[423], NULLOT, &_types[423] },
    { "viewTrapSpecifics", "1.3.6.1.3.11.5.1.3", &_names[423],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[40], NULLOT, NULLOT, &_types[424] },
    { "viewTrapType", "1.3.6.1.3.11.5.1.4", &_names[424],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[420], &_types[421], NULLOT, &_types[425] },
    { "viewTranTable", "1.3.6.1.3.11.6", &_names[425],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[419], NULLOT, &_types[426], &_types[426] },
    { "viewTranEntry", "1.3.6.1.3.11.6.1", &_names[426],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[424], NULLOT, &_types[431], &_types[427] },
    { "viewSourceName", "1.3.6.1.3.11.6.1.1", &_names[427],
      (OS) 6, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[394], &_types[429], NULLOT, &_types[428] },
    { "viewSourceSubtree", "1.3.6.1.3.11.6.1.2", &_names[428],
      (OS) 6, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[381], &_types[430], NULLOT, &_types[429] },
    { "viewTargetName", "1.3.6.1.3.11.6.1.3", &_names[429],
      (OS) 6, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[427], NULLOT, NULLOT, &_types[430] },
    { "viewTargetSubtree", "1.3.6.1.3.11.6.1.4", &_names[430],
      (OS) 6, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[428], &_types[427], NULLOT, &_types[431] },
    { "viewTranType", "1.3.6.1.3.11.6.1.5", &_names[431],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[426], &_types[428], NULLOT, &_types[432] },
    { "private", "1.3.6.1.4", &_names[432],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[390], &_types[433], &_types[433] },
    { "enterprises", "1.3.6.1.4.1", &_names[433],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, &_types[545], &_types[434] },
    { "unix", "1.3.6.1.4.1.4", &_names[434],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[422], NULLOT, &_types[451], &_types[435] },
    { "agents", "1.3.6.1.4.1.4.1", &_names[435],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[1], &_types[466], &_types[437], &_types[436] },
    { "fourBSD-isode", "1.3.6.1.4.1.4.1.2", &_names[436],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[430], NULLOT, NULLOT, &_types[437] },
    { "agentAction", "1.3.6.1.4.1.4.1.3", &_names[437],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[405], &_types[436], NULLOT, &_types[438] },
    { "mbuf", "1.3.6.1.4.1.4.2", &_names[438],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[530], &_types[435], &_types[439], &_types[439] },
    { "mbufs", "1.3.6.1.4.1.4.2.1", &_names[439],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[438], &_types[443], NULLOT, &_types[440] },
    { "mbufClusters", "1.3.6.1.4.1.4.2.2", &_names[440],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[226], &_types[441], NULLOT, &_types[441] },
    { "mbufFreeClusters", "1.3.6.1.4.1.4.2.3", &_names[441],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[440], &_types[442], NULLOT, &_types[442] },
    { "mbufDrops", "1.3.6.1.4.1.4.2.4", &_names[442],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[517], NULLOT, NULLOT, &_types[443] },
    { "mbufWaits", "1.3.6.1.4.1.4.2.5", &_names[443],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[503], &_types[445], NULLOT, &_types[444] },
    { "mbufDrains", "1.3.6.1.4.1.4.2.6", &_names[444],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[345], &_types[450], NULLOT, &_types[445] },
    { "mbufFrees", "1.3.6.1.4.1.4.2.7", &_names[445],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[541], &_types[446], NULLOT, &_types[446] },
    { "mbufTable", "1.3.6.1.4.1.4.2.8", &_names[446],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[532], &_types[444], &_types[447], &_types[447] },
    { "mbufEntry", "1.3.6.1.4.1.4.2.8.1", &_names[447],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[537], NULLOT, &_types[448], &_types[448] },
    { "mbufType", "1.3.6.1.4.1.4.2.8.1.1", &_names[448],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[447], &_types[449], NULLOT, &_types[449] },
    { "mbufAllocates", "1.3.6.1.4.1.4.2.8.1.2", &_names[449],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[442], NULLOT, NULLOT, &_types[450] },
    { "mbufSpaces", "1.3.6.1.4.1.4.2.9", &_names[450],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[440], NULLOT, &_types[451] },
    { "peers", "1.3.6.1.4.1.4.3", &_names[451],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[434], &_types[509], &_types[452], &_types[452] },
    { "unixd", "1.3.6.1.4.1.4.3.1", &_names[452],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[451], NULLOT, NULLOT, &_types[453] },
    { "smux", "1.3.6.1.4.1.4.4", &_names[453],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[350], NULLOT, &_types[454], &_types[454] },
    { "smuxPeerTable", "1.3.6.1.4.1.4.4.1", &_names[454],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[446], &_types[460], &_types[455], &_types[455] },
    { "smuxPeerEntry", "1.3.6.1.4.1.4.4.1.1", &_names[455],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[448], NULLOT, &_types[456], &_types[456] },
    { "smuxPindex", "1.3.6.1.4.1.4.4.1.1.1", &_names[456],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[454], &_types[458], NULLOT, &_types[457] },
    { "smuxPidentity", "1.3.6.1.4.1.4.4.1.1.2", &_names[457],
      (OS) 6, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[194], &_types[459], NULLOT, &_types[458] },
    { "smuxPdescription", "1.3.6.1.4.1.4.4.1.1.3", &_names[458],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[135], &_types[457], NULLOT, &_types[459] },
    { "smuxPstatus", "1.3.6.1.4.1.4.4.1.1.4", &_names[459],
      (OS) 27, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, NULLOT, &_types[460] },
    { "smuxTreeTable", "1.3.6.1.4.1.4.4.2", &_names[460],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[456], NULLOT, &_types[461], &_types[461] },
    { "smuxTreeEntry", "1.3.6.1.4.1.4.4.2.1", &_names[461],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[455], NULLOT, &_types[464], &_types[462] },
    { "smuxTsubtree", "1.3.6.1.4.1.4.4.2.1.1", &_names[462],
      (OS) 6, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[66], &_types[463], NULLOT, &_types[463] },
    { "smuxTpriority", "1.3.6.1.4.1.4.4.2.1.2", &_names[463],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[462], &_types[465], NULLOT, &_types[464] },
    { "smuxTindex", "1.3.6.1.4.1.4.4.2.1.3", &_names[464],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[445], &_types[462], NULLOT, &_types[465] },
    { "smuxTstatus", "1.3.6.1.4.1.4.4.2.1.4", &_names[465],
      (OS) 28, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[460], NULLOT, NULLOT, &_types[466] },
    { "netstat", "1.3.6.1.4.1.4.5", &_names[466],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[356], &_types[453], &_types[467], &_types[467] },
    { "unixNetstat", "1.3.6.1.4.1.4.5.1", &_names[467],
      (OS) 29, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[466], &_types[468], NULLOT, &_types[468] },
    { "unixTcpConnTable", "1.3.6.1.4.1.4.5.2", &_names[468],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[465], &_types[472], &_types[469], &_types[469] },
    { "unixTcpConnEntry", "1.3.6.1.4.1.4.5.2.1", &_names[469],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[461], NULLOT, &_types[470], &_types[470] },
    { "unixTcpConnSendQ", "1.3.6.1.4.1.4.5.2.1.1", &_names[470],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[459], &_types[471], NULLOT, &_types[471] },
    { "unixTcpConnRecvQ", "1.3.6.1.4.1.4.5.2.1.2", &_names[471],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[470], NULLOT, NULLOT, &_types[472] },
    { "unixUdpTable", "1.3.6.1.4.1.4.5.3", &_names[472],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[468], &_types[478], &_types[473], &_types[473] },
    { "unixUdpEntry", "1.3.6.1.4.1.4.5.3.1", &_names[473],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[469], NULLOT, &_types[474], &_types[474] },
    { "unixUdpRemAddress", "1.3.6.1.4.1.4.5.3.1.1", &_names[474],
      (OS) 8, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[449], &_types[475], NULLOT, &_types[475] },
    { "unixUdpRemPort", "1.3.6.1.4.1.4.5.3.1.2", &_names[475],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[444], &_types[476], NULLOT, &_types[476] },
    { "unixUdpSendQ", "1.3.6.1.4.1.4.5.3.1.3", &_names[476],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[471], &_types[477], NULLOT, &_types[477] },
    { "unixUdpRecvQ", "1.3.6.1.4.1.4.5.3.1.4", &_names[477],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[476], NULLOT, NULLOT, &_types[478] },
    { "unixIpRoutingTable", "1.3.6.1.4.1.4.5.4", &_names[478],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[472], &_types[488], &_types[479], &_types[479] },
    { "unixIpRouteEntry", "1.3.6.1.4.1.4.5.4.1", &_names[479],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[473], NULLOT, &_types[481], &_types[480] },
    { "unixIpRouteFlags", "1.3.6.1.4.1.4.5.4.1.1", &_names[480],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[453], &_types[482], NULLOT, &_types[481] },
    { "unixIpRouteRefCnt", "1.3.6.1.4.1.4.5.4.1.2", &_names[481],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[543], &_types[480], NULLOT, &_types[482] },
    { "unixIpRouteUses", "1.3.6.1.4.1.4.5.4.1.3", &_names[482],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[509], NULLOT, NULLOT, &_types[483] },
    { "unixRouteBadRedirects", "1.3.6.1.4.1.4.5.5", &_names[483],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[458], &_types[484], NULLOT, &_types[484] },
    { "unixRouteCreatedByRedirects", "1.3.6.1.4.1.4.5.6", &_names[484],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[483], &_types[485], NULLOT, &_types[485] },
    { "unixRouteModifiedByRedirects", "1.3.6.1.4.1.4.5.7", &_names[485],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[484], &_types[486], NULLOT, &_types[486] },
    { "unixRouteLookupFails", "1.3.6.1.4.1.4.5.8", &_names[486],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[149], &_types[487], NULLOT, &_types[487] },
    { "unixRouteWildcardUses", "1.3.6.1.4.1.4.5.9", &_names[487],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[482], NULLOT, NULLOT, &_types[488] },
    { "unixClnpRoutingTable", "1.3.6.1.4.1.4.5.10", &_names[488],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[478], &_types[483], &_types[489], &_types[489] },
    { "unixClnpRouteEntry", "1.3.6.1.4.1.4.5.10.1", &_names[489],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[479], NULLOT, &_types[491], &_types[490] },
    { "unixClnpRouteFlags", "1.3.6.1.4.1.4.5.10.1.1", &_names[490],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[480], &_types[492], NULLOT, &_types[491] },
    { "unixClnpRouteRefCnt", "1.3.6.1.4.1.4.5.10.1.2", &_names[491],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[481], &_types[490], NULLOT, &_types[492] },
    { "unixClnpRouteUses", "1.3.6.1.4.1.4.5.10.1.3", &_names[492],
      (OS) 10, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[487], NULLOT, NULLOT, &_types[493] },
    { "print", "1.3.6.1.4.1.4.6", &_names[493],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[417], &_types[438], &_types[494], &_types[494] },
    { "printQTable", "1.3.6.1.4.1.4.6.1", &_names[494],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[425], &_types[501], &_types[495], &_types[495] },
    { "printQEntry", "1.3.6.1.4.1.4.6.1.1", &_names[495],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[431], NULLOT, &_types[499], &_types[496] },
    { "printQName", "1.3.6.1.4.1.4.6.1.1.1", &_names[496],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[429], &_types[500], NULLOT, &_types[497] },
    { "printQStatus", "1.3.6.1.4.1.4.6.1.1.2", &_names[497],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[436], &_types[496], NULLOT, &_types[498] },
    { "printQDisplay", "1.3.6.1.4.1.4.6.1.1.3", &_names[498],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[235], NULLOT, NULLOT, &_types[499] },
    { "printQEntries", "1.3.6.1.4.1.4.6.1.1.4", &_names[499],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[495], &_types[497], NULLOT, &_types[500] },
    { "printQAction", "1.3.6.1.4.1.4.6.1.1.5", &_names[500],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[437], &_types[498], NULLOT, &_types[501] },
    { "printJTable", "1.3.6.1.4.1.4.6.2", &_names[501],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[494], NULLOT, &_types[502], &_types[502] },
    { "printJEntry", "1.3.6.1.4.1.4.6.2.1", &_names[502],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[499], NULLOT, &_types[505], &_types[503] },
    { "printJRank", "1.3.6.1.4.1.4.6.2.1.1", &_names[503],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[435], &_types[504], NULLOT, &_types[504] },
    { "printJName", "1.3.6.1.4.1.4.6.2.1.2", &_names[504],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[496], &_types[506], NULLOT, &_types[505] },
    { "printJOwner", "1.3.6.1.4.1.4.6.2.1.3", &_names[505],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[357], &_types[507], NULLOT, &_types[506] },
    { "printJDescription", "1.3.6.1.4.1.4.6.2.1.4", &_names[506],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[500], &_types[508], NULLOT, &_types[507] },
    { "printJSize", "1.3.6.1.4.1.4.6.2.1.5", &_names[507],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[362], &_types[503], NULLOT, &_types[508] },
    { "printJAction", "1.3.6.1.4.1.4.6.2.1.6", &_names[508],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[506], NULLOT, NULLOT, &_types[509] },
    { "users", "1.3.6.1.4.1.4.7", &_names[509],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[416], &_types[531], &_types[510], &_types[510] },
    { "userTable", "1.3.6.1.4.1.4.7.1", &_names[510],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[501], &_types[522], &_types[511], &_types[511] },
    { "userEntry", "1.3.6.1.4.1.4.7.1.1", &_names[511],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[502], NULLOT, &_types[516], &_types[512] },
    { "userName", "1.3.6.1.4.1.4.7.1.1.1", &_names[512],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[504], &_types[518], NULLOT, &_types[513] },
    { "userPasswd", "1.3.6.1.4.1.4.7.1.1.2", &_names[513],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[395], &_types[517], NULLOT, &_types[514] },
    { "userID", "1.3.6.1.4.1.4.7.1.1.3", &_names[514],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[507], &_types[515], NULLOT, &_types[515] },
    { "userGroup", "1.3.6.1.4.1.4.7.1.1.4", &_names[515],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[514], &_types[513], NULLOT, &_types[516] },
    { "userQuota", "1.3.6.1.4.1.4.7.1.1.5", &_names[516],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[511], &_types[519], NULLOT, &_types[517] },
    { "userComment", "1.3.6.1.4.1.4.7.1.1.6", &_names[517],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[415], &_types[521], NULLOT, &_types[518] },
    { "userFullName", "1.3.6.1.4.1.4.7.1.1.7", &_names[518],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[512], &_types[520], NULLOT, &_types[519] },
    { "userHome", "1.3.6.1.4.1.4.7.1.1.8", &_names[519],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[505], &_types[514], NULLOT, &_types[520] },
    { "userShell", "1.3.6.1.4.1.4.7.1.1.9", &_names[520],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[452], NULLOT, NULLOT, &_types[521] },
    { "userStatus", "1.3.6.1.4.1.4.7.1.1.10", &_names[521],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[497], &_types[512], NULLOT, &_types[522] },
    { "groupTable", "1.3.6.1.4.1.4.7.2", &_names[522],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[510], &_types[528], &_types[523], &_types[523] },
    { "groupEntry", "1.3.6.1.4.1.4.7.2.1", &_names[523],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[516], NULLOT, &_types[526], &_types[524] },
    { "groupName", "1.3.6.1.4.1.4.7.2.1.1", &_names[524],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[518], NULLOT, NULLOT, &_types[525] },
    { "groupPasswd", "1.3.6.1.4.1.4.7.2.1.2", &_names[525],
      (OS) 4, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[513], &_types[527], NULLOT, &_types[526] },
    { "groupID", "1.3.6.1.4.1.4.7.2.1.3", &_names[526],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[515], &_types[525], NULLOT, &_types[527] },
    { "groupStatus", "1.3.6.1.4.1.4.7.2.1.4", &_names[527],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[521], &_types[524], NULLOT, &_types[528] },
    { "grUserTable", "1.3.6.1.4.1.4.7.3", &_names[528],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[522], NULLOT, &_types[529], &_types[529] },
    { "grUserEntry", "1.3.6.1.4.1.4.7.3.1", &_names[529],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[523], NULLOT, &_types[530], &_types[530] },
    { "grUserStatus", "1.3.6.1.4.1.4.7.3.1.1", &_names[530],
      (OS) 0, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[527], NULLOT, NULLOT, &_types[531] },
    { "unixFs", "1.3.6.1.4.1.4.8", &_names[531],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[493], &_types[532], &_types[532] },
    { "fsTable", "1.3.6.1.4.1.4.8.1", &_names[532],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[528], NULLOT, &_types[533], &_types[533] },
    { "fsTableEntry", "1.3.6.1.4.1.4.8.1.1", &_names[533],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[529], NULLOT, &_types[537], &_types[534] },
    { "fsIdentifier", "1.3.6.1.4.1.4.8.1.1.1", &_names[534],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[338], &_types[536], NULLOT, &_types[535] },
    { "fsName", "1.3.6.1.4.1.4.8.1.1.2", &_names[535],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[524], &_types[541], NULLOT, &_types[536] },
    { "fsMountPoint", "1.3.6.1.4.1.4.8.1.1.3", &_names[536],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[534], &_types[538], NULLOT, &_types[537] },
    { "fsMountType", "1.3.6.1.4.1.4.8.1.1.4", &_names[537],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[533], &_types[540], NULLOT, &_types[538] },
    { "fsMountOptions", "1.3.6.1.4.1.4.8.1.1.5", &_names[538],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[329], NULLOT, NULLOT, &_types[539] },
    { "fsBlockSize", "1.3.6.1.4.1.4.8.1.1.6", &_names[539],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[526], &_types[535], NULLOT, &_types[540] },
    { "fsBlockCount", "1.3.6.1.4.1.4.8.1.1.7", &_names[540],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[359], &_types[543], NULLOT, &_types[541] },
    { "fsBlocksFree", "1.3.6.1.4.1.4.8.1.1.8", &_names[541],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[361], &_types[542], NULLOT, &_types[542] },
    { "fsBlocksAvailable", "1.3.6.1.4.1.4.8.1.1.9", &_names[542],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[544], NULLOT, &_types[543] },
    { "fsInodeCount", "1.3.6.1.4.1.4.8.1.1.10", &_names[543],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[540], &_types[539], NULLOT, &_types[544] },
    { "fsInodesAvailable", "1.3.6.1.4.1.4.8.1.1.11", &_names[544],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[542], &_types[534], NULLOT, &_types[545] },
    { "snmpResearch", "1.3.6.1.4.1.99", &_names[545],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[439], &_types[434], &_types[546], &_types[546] },
    { "functions", "1.3.6.1.4.1.99.3", &_names[546],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[443], &_types[563], &_types[555], &_types[547] },
    { "functAdd", "1.3.6.1.4.1.99.3.1", &_names[547],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[474], &_types[548], NULLOT, &_types[548] },
    { "functSub", "1.3.6.1.4.1.99.3.2", &_names[548],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[545], NULLOT, NULLOT, &_types[549] },
    { "functMul", "1.3.6.1.4.1.99.3.3", &_names[549],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[539], &_types[551], NULLOT, &_types[550] },
    { "functDiv", "1.3.6.1.4.1.99.3.4", &_names[550],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[477], &_types[554], NULLOT, &_types[551] },
    { "functMod", "1.3.6.1.4.1.99.3.5", &_names[551],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[525], &_types[547], NULLOT, &_types[552] },
    { "functNeg", "1.3.6.1.4.1.99.3.6", &_names[552],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[520], &_types[561], NULLOT, &_types[553] },
    { "functXch", "1.3.6.1.4.1.99.3.7", &_names[553],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[563], &_types[558], NULLOT, &_types[554] },
    { "functClr", "1.3.6.1.4.1.99.3.8", &_names[554],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[491], &_types[549], NULLOT, &_types[555] },
    { "functDup", "1.3.6.1.4.1.99.3.9", &_names[555],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[546], &_types[553], NULLOT, &_types[556] },
    { "functPop", "1.3.6.1.4.1.99.3.10", &_names[556],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[485], &_types[552], NULLOT, &_types[557] },
    { "functAbs", "1.3.6.1.4.1.99.3.11", &_names[557],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[508], &_types[550], NULLOT, &_types[558] },
    { "functSgn", "1.3.6.1.4.1.99.3.12", &_names[558],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[535], &_types[560], NULLOT, &_types[559] },
    { "functMin", "1.3.6.1.4.1.99.3.13", &_names[559],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[421], &_types[556], NULLOT, &_types[560] },
    { "functAnd", "1.3.6.1.4.1.99.3.14", &_names[560],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[168], &_types[559], NULLOT, &_types[561] },
    { "functOr", "1.3.6.1.4.1.99.3.15", &_names[561],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, &_types[562], NULLOT, &_types[562] },
    { "functNot", "1.3.6.1.4.1.99.3.16", &_names[562],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[538], &_types[557], NULLOT, &_types[563] },
    { "expressions", "1.3.6.1.4.1.99.4", &_names[563],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[467], NULLOT, &_types[565], &_types[564] },
    { "exprNumber", "1.3.6.1.4.1.99.4.1", &_names[564],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[519], NULLOT, NULLOT, &_types[565] },
    { "exprTable", "1.3.6.1.4.1.99.4.2", &_names[565],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[488], &_types[564], &_types[566], &_types[566] },
    { "exprEntry", "1.3.6.1.4.1.99.4.2.1", &_names[566],
      (OS) -1, 0, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[489], NULLOT, &_types[570], &_types[567] },
    { "exprIndex", "1.3.6.1.4.1.99.4.2.1.1", &_names[567],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[555], &_types[569], NULLOT, &_types[568] },
    { "exprEval", "1.3.6.1.4.1.99.4.2.1.2", &_names[568],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[552], &_types[571], NULLOT, &_types[569] },
    { "exprExpr", "1.3.6.1.4.1.99.4.2.1.3", &_names[569],
      (OS) 3, 3, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[553], &_types[568], NULLOT, &_types[570] },
    { "exprStatus", "1.3.6.1.4.1.99.4.2.1.4", &_names[570],
      (OS) 0, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[548], &_types[567], NULLOT, &_types[571] },
    { "exprHints", "1.3.6.1.4.1.99.4.2.1.5", &_names[571],
      (OS) 4, 1, (u_long) 0, 1,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      &_types[106], NULLOT, NULLOT, &_types[572] },
    { "joint-iso-ccitt", "2", &_names[572],
      (OS) -1, 0, (u_long) 0, 0,
      (caddr_t) 0, NULLIFP, NULLIFP, (caddr_t) 0, (caddr_t) 0,
      NULLOT, NULLOT, NULLOT, NULLOT },
    NULL
};

OT	anchor = _types;
OT	chain = &_types[572];

static OT _Tbuckets[128] = {
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[297],
    NULLOT,
    &_types[327],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[41],
    &_types[346],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[531],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[64],
    &_types[47],
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[561],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[225],
    &_types[450],
    NULLOT,
    &_types[6],
    &_types[492],
    &_types[423],
    &_types[386],
    &_types[536],
    &_types[457],
    &_types[544],
    &_types[102],
    &_types[486],
    &_types[191],
    &_types[568],
    &_types[556],
    &_types[559],
    &_types[475],
    &_types[331],
    &_types[565],
    &_types[463],
    &_types[560],
    &_types[389],
    &_types[464],
    &_types[558],
    &_types[490],
    &_types[380],
    &_types[569],
    &_types[222],
    &_types[567],
    &_types[570],
    &_types[547],
    &_types[551],
    &_types[387],
    &_types[549],
    &_types[351],
    &_types[564],
    &_types[493],
    NULLOT,
    &_types[554],
    NULLOT,
    &_types[566],
    &_types[441],
    &_types[571],
    &_types[498],
    &_types[404],
    NULLOT,
    &_types[550],
    &_types[557],
    &_types[562],
    NULLOT,
    NULLOT,
    NULLOT,
    &_types[403],
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
    NULLOT,
};

extern	int	once_only_Tbuckets;
extern	OT	Tbuckets[];

loadobjects (file)
char   *file;
{
    int	    i;
    register struct _syntax *sy;
    register OT	    ot;
    static int once_only = 0;

    if (file && !once_only)
	return readobjects (file);

    if (once_only) {
	(void) sprintf (PY_pepy, "loadobjects called more than once!");
	return NOTOK;
    }
    once_only = 1;

    bcopy ((char *) _Tbuckets, (char *) Tbuckets, sizeof _Tbuckets);
    once_only_Tbuckets = 1;

    readsyntax ();
    for (sy = _syntaxes; sy -> name; sy++)
	if ((sy -> value = text2syn (sy -> name)) == NULLOS) {
	    (void) sprintf (PY_pepy, "lost \"%s\" syntax", sy -> name);
	    return NOTOK;
	}

    for (ot = _types; ot -> ot_text; ot++)
	ot -> ot_syntax = (i = (int) ot -> ot_syntax) < 0
	    			? NULLOS : _syntaxes[i].value;

    return OK;
}
